use strict;
use warnings;
use lib '../..';
use Games::BinaryishTrees;
use JSON::MaybeXS;

my $file = shift;
$file ||= 'check.json';
my $gbt = new Games::BinaryishTrees;
pairs($gbt);
my $pairset = pairlist();
my $json = JSON::MaybeXS->new(pretty => 1, canonical => 1);
$gbt->writefile($file, $json->encode($gbt->tojson($pairset)));
$pairset = $gbt->fromjson($json->decode($gbt->readfile($file)));
my $solution = $gbt->solve($pairset);
print join("\n", $solution->bestpaths), "\n";
print "json $file written\n";

sub pairs {
  my $gbt = shift;
  $gbt->pair('a', 5, 'a1', undef, undef, {b => [1, 0]});
  $gbt->pair('a1', 4, 0);
  $gbt->pair('j', 'h', 'i');
  $gbt->pair('b', 4, 0);
  $gbt->pair('c', 3, 0);
  $gbt->pair('d', 2, 0);
  $gbt->pair('h', 3, -2);
  $gbt->pair('i', 1, 0);
  $gbt->pair('k', 'l', 'm');
  $gbt->pair('l', 3, -2);
  $gbt->pair('m', 1, 0);
}

sub pairlist {
  return ['a', 'b', 'c', 'k', 'j'];
}

