use strict;
use warnings;
use lib '../lib';
use Games::BinaryishTrees;
use JSON::MaybeXS;

my $gbt = new Games::BinaryishTrees;
$gbt->setwarningsoff(1);

my $bv;

OUTER:while (1) {
  my $loop = 1;
  my @pairset;  

  while ($loop) {
    @pairset = generate($gbt);
    $loop = 0 if @pairset;
  }

  $gbt->pairset(\@pairset);
  print $gbt->view;
#  print $gbt->view([1, 1, 1, 0]);
#  print @pairset, "\n";
#  jsonwrite($gbt, \@pairset);
  jsonwrite($gbt);

  for (0..1) {
    $gbt->setstart(1);
    $gbt->setpass(1);
    $gbt->setpassplus($_);
    $gbt->setpasstax(1);
    $gbt->setstrategy(2);
    my $sol = $gbt->solve();
#    my $sol = $gbt->solve(\@pairset);
#    print $gbt->view([0, 0, 0, 1]);
  #  print $gbt->view;
    if ($_) {
      my $diff = $bv - $sol->bestvalue;
      print "diff is $diff\n";
      last OUTER if $diff != 0;
    } else {
      $bv = $sol->bestvalue;
    }
  #  print join("\n", $sol->bestpaths), "\n";
  }

}

sub generate {
  my $gbt = shift;
  $gbt->deletepair();
  my %ids;

  for (-2..int(rand(4))) {
    $ids{lowercaseletter()} = 1;
  }

  my %pairset = %ids;

  for my $key (keys %ids) {
    my ($result, $type) = pairornumber($key, %ids);
    if ($type eq 'letter') {
      delete $pairset{$result};
    }
    my ($result2, $type2) = pairornumber($key, %ids);
    if ($type2 eq 'letter') {
      delete $pairset{$result2};
    }
    $gbt->pair($key, $result, $result2);
  }

  return keys %pairset;
}

sub pairornumber {
  my ($key, %ids) = @_;
  my ($result, $type);
  if (int(rand(10)) > 2) {
    $result = int(rand(10)) - int(rand(10));
    $type = 'number';
  } else {
    $result = choose(%ids);

    while ($result eq $key) {
      $result = choose(%ids);
    }

    $type = 'letter';
  }
  return $result, $type;
}

sub lowercaseletter {
  return chr(int(rand(26)) + 97);
}

sub choose {
  my %hash = @_;
  my @setups = keys %hash;
  return $setups[rand @setups];
}

sub jsonwrite {
  my ($gbt, $pairset) = @_;
  my $json = JSON::MaybeXS->new(pretty => 1, canonical => 1);
  $gbt->writefile("check.json", $json->encode($gbt->tojson($pairset)));
}

