package Games::BinaryishTrees::Game;

use strict;
use warnings;
#use Games::BinaryishTrees::pairs qw(pair);
use Games::BinaryishTrees::MultiNode;
#use Games::BinaryishTrees::messages qw(message messagewithvariable messageaddsimple changenumber);
#use Games::BinaryishTrees::messages qw(message messagewithvariable messageaddsimple changenumber notsoproudfunction changemessage changemessagewithindexforgame);
use Games::BinaryishTrees::messages qw(message changenumber notsoproudfunction aboveandbelow);
use Games::BinaryishTrees::playgame qw(playgame newgame moveto weight moves bestchoices allchoices legalchoices tree gamepaths playout viewtree);
use Games::BinaryishTrees::utils qw(clone);
use Games::BinaryishTrees::json qw(jsonsolute);
use Carp;
#use Data::Printer;
#use Data::Dumper;

sub new {
  my $this = shift;
  my $class = ref($this) || $this;
  my $self = {};
  $self->{gamepaths} = [];
  $self->{testing} = 0;
  my $gbt = shift;
  $self->{bestpaths} = clone($gbt->{bestpaths});
  $self->{gamebv} = $gbt->{bestvalue};
  $self->{bestvalue} = $gbt->{bestvalue};
  $self->{startflag} = $gbt->{startflag};
  $self->{passtaxflag} = $gbt->{passtaxflag};
  $self->{root} = $gbt->{root};
#  $self->{trees} = clone($gbt->{trees});
#  $self->{options} = clone($gbt->{options});
  $self->{options} = $gbt->{options};
  $self->{kos} = clone($gbt->{kos});
  $self->{pairs} = clone($gbt->{pairs});
  $self->{mnhandle} = $gbt->{mnTree}->{mnhandle};
  $self->{verboseflag} = 0;
  $self->{warningsoffflag} = $gbt->{warningsoffflag};
  $self->{computerplaysflag} = 1;
#  $self->{gbt} = $gbt; #hahaha
  $self->{loopflag} = $gbt->{loopflag};
  $self->{passflag} = $gbt->{passflag};
  $self->{originalpairs} = clone($gbt->{pairs});
#  $self->{pathrepeat} = $gbt->->{pathrepeat}; # look only, look only look
  $self->{pathrepeat} = $gbt->{pathrepeat};
#p $self->{originalpairs};
#  $self->{root} = $gbt->{root};
  newgame($self);
  bless $self, $class;
  return $self;
}

sub verbose {
  my ($self, $value) = @_;
  return setflag($self, 'verboseflag', $value)
}

sub computermove {
  my ($self, $value) = @_;
  return setflag($self, 'computerplaysflag', $value)
}

sub computerplays {
  my ($self, $value) = @_;
  return setflag($self, 'computerplaysflag', $value)
}

sub settesting {
  my ($self, $value, $checkfolder) = @_;
  $self->{checkfolder} = $checkfolder;
  $self->{checkfolder} ||= './answers';
  return setflag($self, 'testing', $value)
}

sub changeallnumbers {
#  my ($self, $toggle, $above, $below, $equal) = @_;
  my ($self, $toggle, $hashref) = @_;
  setflag($self, 'changeallnumbersflag', $toggle);
  if ($toggle) {
#    $self->{aboveandbelow} = {above => $above, below => $below};
#    $self->{aboveandbelow} = {above => $above, below => $below, equal => $equal};
    $self->{aboveandbelow} = $hashref;
  } else {
    $self->{aboveandbelow} = {};
  }
  return $self->{aboveandbelow};
}

sub mitidiot {
  my ($self, $value) = @_;
  return setflag($self, 'verboseflag', $value);
}

sub setflag {
  my ($self, $index, $value) = @_;
  if (defined $value) {
    $self->{$index} = $value ? 1 : 0;
  }
  return $self->{$index};
}

sub bestpaths {
  my ($self, $paths) = @_;
  $paths = $self->{bestpaths} unless defined $paths;
#  if ($self->{verboseflag}) {
#    my %pairs = %{$self->{pairs}}; # prevents auto-creation of $self->{pairs}->{'P'}
#    my %pairscopy = %{$self->{gbt}->{pairs}}; # reset pairs after pooking
    my @output;
    my $pass = message(48);
#    my $toggle = $self->{startflag} % 2 ? 1 : -1;

    for (@{$paths}) {
      my @moves = split ':';
#      push @output, join ':', map {$pairs{$moves[$_]}->[2 + ($_ + $self->{startflag}) % 2] || $moves[$_]} 0..$#moves;
#      push @output, join ':', map {$pairs{$moves[$_]}->[2 + ($_ + $self->{startflag}) % 2] || $pass} 0..$#moves;
      if ($self->{verboseflag}) {
        push @output, join ':', map {makedefaultpaths($self, ($_ + $self->{startflag}) % 2, $moves[$_], $pass)} 0..$#moves;
#        push @output, join ':', map {makedefaultpaths($self, ($_ + $self->{startflag}) % 2, $moves[$_]) || $pass} 0..$#moves;
#        push @output, join ':', map {makedefaultpaths($self, ($_ + $self->{startflag}) % 2, $moves[$_]) || $pass} 0..$#moves; # for look
      } else {
#        push @output, join ':', map {$_ eq 'P' ? message(48) : $_} @moves;
        push @output, join ':', map {$_ eq 'P' ? $pass : $_} @moves;
      }
#      push @output, join ':', map {makedefaultpaths($self->{gbt}, ($_ + $self->{startflag}) % 2, $moves[$_])} 0..$#moves;

#      $toggle *= -1;
    }

#p $self->{pairs};
#    $self->{gbt}->{pairs} = \%pairscopy;
#    return @output;
#  }# else {
#  return @$paths;
  return @output;
#    return map { $_ eq 'P' ? message(48) : $_} @$paths;
#  }
}

sub makedefaultpaths {
  my ($self, $toggle, $id, $pass) = @_;
  my $message;
  if (exists $self->{pairs}->{$id}) {
    my $pairid = $self->{pairs}->{$id};
#    my $message;
#  if (defined $pairid) {
    my ($score, $move) = playout($self, $toggle, $id, $pairid);
    if (!defined $pairid->[2 + $toggle]) {
#      my $plural = $score == 1 ? '' : message(22); # hoho theres only one theres one of
#      my $plural = $score == 1 ? message(61) : message(22); # hoho theres only one theres one of
      my $plural = $score == 1 ? message(62) : message(22); # hoho theres only one theres one of
      my $leftorright = $toggle ? message(55) : message(56);
      my $idornumber = $move ? message(52, $move) : message(53, $score, $plural);
      $message = message(54, $leftorright, $id, $idornumber);
    } else {
      $message = $pairid->[2 + $toggle];
    }

#    if (defined $pairid->[4]) {
#
#      while (my ($k, $v) = each %{$pairid->[4]}) {
##        $self->pair($k, @$v);
#        Games::BinaryishTrees::pair($self, $k, @$v);
##        $self->_pair($k, @$v);
#      }
#
#    }

  } else {
    $message = $pass;
  }

#print "message is $message\n";
  return $message;
}

sub newtree {
  my $self = shift;
  
}

sub bestvalue {
#  $_[0]->{bestvalue};
  my $self = shift;
  my $numerals;
  if ($self->{changeallnumbersflag}) {
    $numerals = aboveandbelow($self->{aboveandbelow}, $self->{bestvalue});
  } else {
    $numerals = notsoproudfunction($self->{bestvalue});
  }
#  my $message = $self->{gbt}->{sweetflag} ? message(59) : '';
#  my $message = $self->{gbt}->{sweetflag} ? message(59, $numerals) : '';
#  my $message = $self->{gbt}->{sweetflag} ? message(59, $numerals) : $numerals;
#  return $message;
  return $numerals;
#  return "$message $numerals";
}

sub bestvaluesigned {
  my ($self, $path) = @_;
  my $message;
#  my $end = join '', ':', message(48), ':', message(48);
#  $path = reversetopass(61, $path);
#  my $end = join '', ':', message(61), ':', message(61);
  my $m61 = message(61);
#  if ($path =~ /$end$/) {
  if ($path =~ /:($m61|P):($m61|P)/) {
    if (moveto($self, $path)) {
      $message = bestvalue($self);
    } else {
      $message = message(59);
    }
  } else {
    $message = message(60);
  }
  return $message;
}

=sigh
sub bestvaluesignedlong {
  my ($self, $path) = @_;
  my $score;
  my @moves = split ':', $path;

  for my $index (0..$#moves) {
    my $pairid = $self->{gbt}->{pairs}->{$moves[$index]};
    my $toggle = ($index + $self->{startflag}) % 2;
    if (defined $pairid) {
      (my $thisscore, undef) = playout($self->{gbt}, $toggle, $moves[$index], $pairid);
      $score += $thisscore;
    } else {
#print "move $moves[$index]\n";
      my $sign = $toggle ? 1 : -1;
      $score += $self->{gbt}->{passtaxflag} * $sign;
    }
  }

  if ($self->{gbt}->{lmbflag}) {
    my $toggle = $self->{startflag} % 2 ? -1 : 1;
    $score += (@moves % 2) * $toggle;
  }

  return notsoproudfunction($score);
}
=cut

sub changethisnumber {
  my $self = shift;
  my $index = shift; # 0-9 # 
  my $newnumber = shift;
#  return changethisnumber(@_);
#  return changenumber(@_); # noshnosh
#  return changenumber(shift);
#  return changenumber($newnumber);
#  return changenumber($index, $newnumber);
  if ($index =~ /^\d$/) {
    return changenumber($index, $newnumber);
  } else {
    return message(58, $index);
  }
}

=hmm
sub settesting {
  my ($self, $value) = @_;
  if (defined $value) {
    $self->{testing} = $value ? 1 : 0;
  }
  return $self->{testing};
}
=cut
1;
