package Games::BinaryishTrees::Trees::chooser;

use strict;
use warnings;

use Games::BinaryishTrees::Trees::Loopoptions;
use Games::BinaryishTrees::Trees::Loop;
use Games::BinaryishTrees::Trees::Simple;
use Games::BinaryishTrees::Trees::Pook;
use Games::BinaryishTrees::Trees::Steps;
use Games::BinaryishTrees::Trees::StepsTwo;
use Games::BinaryishTrees::Trees::Options;
use Games::BinaryishTrees::Trees::Complex;

sub load {
  my ($gbt, $game) = @_;
  my $solution;
  if ($game eq 'loopoptions') {
    Games::BinaryishTrees::Trees::Loopoptions::pairs($gbt);
    $solution = $gbt->solve(Games::BinaryishTrees::Trees::Loopoptions::pairlist());
  } elsif ($game eq 'loop') {
    Games::BinaryishTrees::Trees::Loop::pairs($gbt);
    $solution = $gbt->solve(Games::BinaryishTrees::Trees::Loop::pairlist());
  } elsif ($game eq 'simple') {
    Games::BinaryishTrees::Trees::Simple::pairs($gbt);
    $solution = $gbt->solve(Games::BinaryishTrees::Trees::Simple::pairlist());
  } elsif ($game eq 'pook') {
    Games::BinaryishTrees::Trees::Pook::pairs($gbt);
    $solution = $gbt->solve(Games::BinaryishTrees::Trees::Pook::pairlist());
  } elsif ($game eq 'steps') {
    Games::BinaryishTrees::Trees::Steps::pairs($gbt);
    $solution = $gbt->solve(Games::BinaryishTrees::Trees::Steps::pairlist());
  } elsif ($game eq 'stepstwo') {
    Games::BinaryishTrees::Trees::StepsTwo::pairs($gbt);
    $solution = $gbt->solve(Games::BinaryishTrees::Trees::StepsTwo::pairlist());
  } elsif ($game eq 'options') {
    Games::BinaryishTrees::Trees::Options::pairs($gbt);
    $solution = $gbt->solve(Games::BinaryishTrees::Trees::Options::pairlist());
  } elsif ($game eq 'complex') {
    Games::BinaryishTrees::Trees::Complex::pairs($gbt);
    $solution = $gbt->solve(Games::BinaryishTrees::Trees::Complex::pairlist());
  }
  return $solution;
}

1;
