package Games::BinaryishTrees::filer;

use strict;
use warnings;
use Carp;
use Games::BinaryishTrees::messages qw(message);

require Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = qw(readfolder writefile readfile);

sub readfolder { # lowercase and lose .pm
  my $dir = shift;
  opendir(my $dh, $dir) or croak message(77, $dir, $!);
  my @files = map { lc s/.pm$//r } grep { $_ !~ /chooser.pm/ } grep { -f "$dir/$_" } sort readdir($dh);
  closedir $dh;
  return @files;
}

sub writefile {
  my ($self, $filepath, $data) = @_;
  open(my $fh, '>', $filepath) or croak message(78, $filepath);
  print $fh $data;
  close($fh);
}

sub readfile {
  my ($self, $filepath) = @_;
  my $content;
#  open(my $fh, '<', $filepath) or croak "could not open file $filepath";
  open(my $fh, '<', $filepath) or croak message(79, $filepath);
  {
    local $/;
    $content = <$fh>;
  }
  close($fh);
  return $content;
}

1;
