package Games::BinaryishTrees::json;

use strict;
use warnings;
use Games::BinaryishTrees::messages qw(message);
use Carp;

require Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = qw(tojson fromjson jsonsolute);

sub tojson {
  my ($gbt, $pairset) = @_;
  $pairset ||= $gbt->{trees};
  my $hash = {pairs => $gbt->{pairs}, pairset => $pairset, options => $gbt->{options}, settings => [$gbt->setparams]};
  # + viewer => $gbt->view';' \n is \n
  return $hash;
}

sub fromjson {
  my ($gbt, $json, $hash) = @_;
  my $overwrite = exists $hash->{overwrite} ? $hash->{overwrite} : 1;
  $gbt->setparams(@{$json->{settings}});
  $gbt->deletepair() if $overwrite;

  for my $pair (keys %{$json->{pairs}}) {
    my @pairstuff = ($pair, @{$json->{pairs}->{$pair}});
    $gbt->pair(@pairstuff);
  }

  $gbt->deleteoption() if $overwrite;
#  $gbt->{options} = {};
#  while (my ($toggle, $hash) = each %{$json->{options}}) {
#    while (my ($pairid, $optionlist) = each %{$hash}) {
  for my $toggle (keys %{$json->{options}}) {

    for my $pairid (keys %{$json->{options}->{$toggle}}) {
#      my @pairstuff = ($toggle eq -1 ? $gbt->message(49) : $gbt->message(50), $pairid, @{$optionlist});
      my @pairstuff = ($toggle eq -1 ? message(49) : message(50), $pairid, @{$json->{options}->{$toggle}->{$pairid}});
      $gbt->option(@pairstuff);
    }

  }

  $gbt->pairset($json->{pairset}) if $overwrite;
  return $json->{pairset};
}

sub jsonsolute {
	my ($solution, $jsonpackage, $jsonencodefunction) = @_;
  $jsonpackage ||= 'JSON::MaybeXS';
	$jsonencodefunction ||= 'encode';
  eval "require $jsonpackage";
  if ($@) {
		croak message(84, $jsonpackage);
	} else {
		my $hash = {bestpaths => [$solution->bestpaths], bestvalue => $solution->bestvalue};
		my $json = $jsonpackage->new(pretty => 1, canonical => 1);
		my $encoded = $json->$jsonencodefunction($hash);
		return $encoded;
	}
}

1;
