package Games::BinaryishTrees::mnTree;

use strict;
use warnings;
use Games::BinaryishTrees::MultiNode;
#use Games::BinaryishTrees::utils qw(arraycompare);
#use Data::Dumper;
#use Storable;
#use Data::Printer;
#use Carp;

sub new {
  my $this = shift;
  my $class = ref($this) || $this;
#  my $process = shift ? \&postprocessquicker : \&postprocess;
#  my $process = \&postprocess;
#print "process ", shift, "\n";
  my ($startflag, $leaves, $sweetflag, $root, $strategyvaue) = @_; # sweetflag as yet always false # things change - processflag (invisible via shift) sets solver leafprocess
#print Dumper @_;
#  my $process = \&postprocess if $sweetflag; # 
#  $process = \&postprocess if $sweetflag; # commented as jumout when find 0
#  $process = \&postprocess if $sweetflag;
#  my $process = $sweetflag ? \&postprocesssweet : \&postprocess;
  my $processhash = { 0 => \&postprocess, 1 => \&postprocesssweet, 2 => \&postprocessadd };
  my $process = $processhash->{$sweetflag};
  $process = $processhash->{$strategyvaue} if defined $strategyvaue;
#$process = \&postprocessadd;
#print "sweetflag is $sweetflag\n";
#print Dumper $process; # sub { dummy }
#print "$process\n"; # changes each run
  my $self = {};
  bless $self, $class;
#  $self->{thistree} = Games::BinaryishTrees::MultiNode->new();
  $self->{thistree} = Games::BinaryishTrees::MultiNode->new($root);
  $self->{mnhandle} = Games::BinaryishTrees::MultiNode::Handle->new($self->{thistree});
#print Dumper $leaves;
  putintreefaster($self->{mnhandle}->{curr_node}, $leaves);
#$self->{mnhandle}->dumptree();
#store $self->{mnhandle}, 'file'; # store here or after minimaxloopwalk
  $self->{mnhandle}->top();
#$self->{mnhandle} = retrieve('file'); # do this or putintree
#return $self, cleanup($self->{mnhandle}->get_data());
#print $self->{mnhandle}->dumptree('top');
#  return $self, cleanup(minimaxloopwalk($self, $startflag, $process, $self->{mnhandle}->{curr_node}), $root);
  $self->{startflag} = $startflag;
  $self->{process} = $process;
  $self->{root} = $root;
  return $self;
}

sub putintreeneater { # ~ 6% slower # we add P:P to the end in case of a:P:b:P:P and a:P:P (?)
  my ($curr_node, $leaves) = @_;
  my @sorted = sort keys %{$leaves};
  my $firstpath = shift @sorted;
  my @firstmoves = split ':', $firstpath;
  $curr_node = addnode ($curr_node, $firstpath, $leaves->{$firstpath}, @firstmoves);
  my $previouspath = $firstpath;	

  for my $path (@sorted) {
    (my $ups, $previouspath, my @moves) = arraycompare($path, $previouspath);
	  $curr_node = $curr_node->{parent} for 1..$ups;
    $curr_node = addnode ($curr_node, $path, $leaves->{$path}, @moves);
    $previouspath = $path;
  }

}

sub putintreefaster { # we add P:P to the end in case of a:P:b:P:P and a:P:P (?)
  my ($curr_node, $leaves) = @_;
  my @sorted = sort keys %{$leaves};
  my $firstpath = shift @sorted;
  my @firstmoves = split ':', $firstpath;
  pop @firstmoves;
#$curr_node = addnode ($curr_node, $firstpath, $leaves->{$firstpath}, $firstpath);
#print @firstmoves, "\n";
  for (@firstmoves) {
    push @{$curr_node->{children}},
      Games::BinaryishTrees::MultiNode::Node->new($curr_node, $_);
#        Games::BinaryishTrees::MultiNode::Node->new($curr_node, $_, $firstpath); # for pathanswers
    $curr_node = $curr_node->{children}->[-1];
  }

  push @{$curr_node->{children}}, 
    Games::BinaryishTrees::MultiNode::Node->new($curr_node, 'P', $firstpath, $leaves->{$firstpath});
  my $previouspath = $firstpath;	

  for my $path (@sorted) {
    ($previouspath ^ $path) =~ /[^\0]/;
    my $ups = substr($previouspath, $-[0]) =~ tr/://;
#    my ($ups, $previouspath, @moves) = arraycompare($path, $previouspath);
	  $curr_node = $curr_node->{parent} for 1..$ups;
    my $startmatch = substr($path, 0, $-[0]);
    my $endmatch = substr($path, $-[0]);
    if ($startmatch !~ /:$/) {
      my @array = split(':', $startmatch);
      $endmatch = $array[-1].$endmatch;
    }
#$curr_node = addnode ($curr_node, $path, $leaves->{$path}, $endmatch);
    my @moves = split(':', $endmatch);
    pop @moves; # we know the last move is 'P'

    for (@moves) {
      push @{$curr_node->{children}},
        Games::BinaryishTrees::MultiNode::Node->new($curr_node, $_);
#        Games::BinaryishTrees::MultiNode::Node->new($curr_node, $_, $startmatch);
      $curr_node = $curr_node->{children}->[-1];
    }

    push @{$curr_node->{children}}, 
      Games::BinaryishTrees::MultiNode::Node->new($curr_node, 'P', $path, $leaves->{$path});
    $previouspath = $path;
  }
# croak # to see  ~ 100% storage use
}
=scruffy
sub putintree { # we add P:P to the end in case of a:P:b:P:P and a:P:P (?)
  my ($curr_node, $leaves) = @_;
#  my ($previouspath, $counter) = ([], 0);
#  my ($previouspath, $counter) = ('', 0);
#  my $previouspath = '';
  my @sorted = sort keys %{$leaves};
  my $firstpath = shift @sorted;
#  my @firstmoves = split ':', $firstpath;
#  pop @moves;
#  my $previouspath = $firstpath;
$curr_node = addnode ($curr_node, $firstpath, $leaves->{$firstpath}, $firstpath);

#  for (@firstmoves) {
#    push @{$curr_node->{children}},
#      Games::BinaryishTrees::MultiNode::Node->new($curr_node, $_);
##        Games::BinaryishTrees::MultiNode::Node->new($curr_node, ++$counter, $_, $startmatch);
#    $curr_node = $curr_node->{children}->[-1];
#  }

#  push @{$curr_node->{children}}, 
#    Games::BinaryishTrees::MultiNode::Node->new($curr_node, 'P', $firstpath, $leaves->{$firstpath});
  my $previouspath = $firstpath;	

  for my $path (@sorted) {
#print "path is $path\n";
    ($previouspath ^ $path) =~ /[^\0]/;
    my $ups = substr($previouspath, $-[0]) =~ tr/://;
#print "ups is $ups\n";
#    my $ups = substr($previouspath, $-[0]) =~ s/://g; # giveswarning s w
#print '~', @{$previouspath}, '~', $path, "\n";
#    my ($ups, $previouspath, @moves) = arraycompare($path, $previouspath);
#    (my $ups, $previouspath, @moves) = arraycompare($path, $previouspath);
#    $ups = $counter ? $ups : 0;
	  $curr_node = $curr_node->{parent} for 1..$ups;
#print 'ups ', $ups, ' ', @moves, "\n";
    my $startmatch = substr($path, 0, $-[0]);
    my $endmatch = substr($path, $-[0]);
#print "$startmatch $endmatch\n";
#    if ($startmatch !~ /:$/ && $counter != 0) { # $counter test avoids when $startmatch is empty # do once first instead
    if ($startmatch !~ /:$/) {
#print "not matched\n";
      my @array = split(':', $startmatch);
      $endmatch = $array[-1].$endmatch;
    }
#print "$startmatch $endmatch\n";
#    my @moves = split(':', substr($path, $-[0]));
$curr_node = addnode ($curr_node, $path, $leaves->{$path}, $endmatch);
#    my @moves = split(':', $endmatch);
#    my @path = split(':', $path);
#    my $start = $counter == 0 ? 0 : $#path - $ups;
#    my @moves = @path[ $start .. $#path ];
#    pop @moves; # we know the last move is 'P'

#    for (@moves) {
#      push @{$curr_node->{children}},
#        Games::BinaryishTrees::MultiNode::Node->new($curr_node, $_);
##        Games::BinaryishTrees::MultiNode::Node->new($curr_node, ++$counter, $_);
##        Games::BinaryishTrees::MultiNode::Node->new($curr_node, ++$counter, $_, $startmatch);
#      $curr_node = $curr_node->{children}->[-1];
##print "cn id is $curr_node->{id}\n";
#    }

#    push @{$curr_node->{children}}, 
#      Games::BinaryishTrees::MultiNode::Node->new($curr_node, 'P', $path, $leaves->{$path});
##      Games::BinaryishTrees::MultiNode::Node->new($curr_node, ++$counter, 'P', $path, $leaves->{$path});
    $previouspath = $path;
  }
## croak # to see  ~ 100% storage use
}
=cut

sub addnode { # small slower
  my ($curr_node, $path, $value, @moves) = @_;
#  my ($curr_node, $path, $value, $str) = @_;

#  my @moves = split(':', $str);
  pop @moves; # we know the last move is 'P'

  for (@moves) {
    push @{$curr_node->{children}},
      Games::BinaryishTrees::MultiNode::Node->new($curr_node, $_);
    $curr_node = $curr_node->{children}->[-1];
  }

  push @{$curr_node->{children}}, 
    Games::BinaryishTrees::MultiNode::Node->new($curr_node, 'P', $path, $value);

  return $curr_node;
}

sub postprocess {
#print "postprocess\n";
#  my ($curr_node, $level, undef, $self) = @_;
  my ($curr_node, $level) = @_;
  my @children = @{$curr_node->{children}};
  if (@children) {
    $level = !$level;
#    postprocess($_, $level, undef, $self) for @children;
    postprocess($_, $level) for @children;
#    handleminimax($curr_node, $level % 2, $self, @children);
    $curr_node->{value} = $children[0]->{value};
    $curr_node->{key} = $children[0]->{key};
    shift @children;
#    handleminimax($curr_node, $level % 2, @children) if @children;
    setminimaxnodes($curr_node, $_->{value}, $level) for @children;
  }
}

sub postprocesssweet {
#print "postprocesssweet\n";
  my $curr_node = shift;
  my @children = @{$curr_node->{children}};
  if (@children) {
    postprocesssweet($_) for @children;
#    handleminimaxsweet($curr_node, undef, @children); # undef helps when uncommenting sweet plays mean
    $curr_node->{value} = abs($children[0]->{value});
    $curr_node->{key} = $children[0]->{key};
    shift @children;
#    handleminimaxsweet($curr_node, @children) if @children;
    setsweetnodes($curr_node, abs($_->{value})) for @children;
  }
}

sub postprocessadd {
#print "postprocesssweet\n";
  my $curr_node = shift;
  my @children = @{$curr_node->{children}};
  if (@children) {
    postprocessadd($_) for @children;
#    handleminimaxsweet($curr_node, undef, @children); # undef helps when uncommenting sweet plays mean
    $curr_node->{value} = $children[0]->{value};
    $curr_node->{key} = $children[0]->{key};
    shift @children;
#    handleminimaxadd($curr_node, @children) if @children;
    setaddnodes($curr_node, $_->{value}) for @children;
  }
}

sub postprocessspm {
  my ($curr_node, $level) = @_;
  my @children = @{$curr_node->{children}};
  if (@children) {
    $level = !$level;
    postprocessspm($_, $level) for @children;
    $curr_node->{value} = ($level ? abs($children[0]->{value}) : $children[0]->{value});
    $curr_node->{key} = $children[0]->{key};
    shift @children;
    setspmnodes($curr_node, $_->{value}, $level) for @children;
  }
}

# out of order
# most of the improvement comes from optleaves via solver
# perl -d:NYTProf to investigate
=outoforder
sub postprocessquicker { # sweetflag always uses postprocess
#print "postprocessquicker\n";
#  my ($curr_node, $sweetflag, $level, $tracker) = @_;
#  my ($curr_node, $level, $tracker, $self) = @_;
  my ($curr_node, $level, $tracker) = @_;
  my @children = @{$curr_node->{children}};
  my $retval;
  if (@children) {
    my $hmm = 1;
    $level++;

    for (0..$#children) {
#print "doing children $#children\n";
      my $thischild = $curr_node->{children}->[$_];
#      my $value = postprocessquicker($thischild, $sweetflag, $level, $tracker);
      my $value = postprocessquicker($thischild, $level, $tracker);
#      last unless $value;
#      last if $sweetflag && $value == 0;
      if ($_ != $#children) { # 'last' won't save much time when this is the last one anyway
#        my $ml = $tracker->{$level}; # ?
#        my $ml = {};
#print Dumper "$ml\n";
#        $ml->{value} = $value; # ?
#print "now is\n", Dumper "$ml\n";
#        my $parentkey = $thischild->{parent}->{counter};
#print "ml parent is $ml->{parent}\n";
#        if (($ml->{parent} || 0) ne $parentkey) {
#          $ml->{parent} = $parentkey;
#          $ml->{gparent} = $thischild->{parent}->{parent}->{counter};
#        }
#print "here is\n", Dumper "$ml\n";
#print "parent is $ml->{parent}\n";
#        my $mlminus = $tracker->{$level - 1}->{value};
#        if (defined $mlminus && $ml->{gparent} == $tracker->{$level - 1}->{parent}) {
#          my $jumpout = ($ml->{value} - $mlminus) * ($level % 2 ? -1 : 1);
#          if ($sweetflag ? $jumpout == 0 : $jumpout > 0) { # <= 0 when sweetflag?
#          if ($sweetflag ? $mlminus == 0 : $jumpout > 0) { # working
#          if ($sweetflag ? $ml->{value} == 0 : $jumpout > 0) { # not working
#          if ($sweetflag ? ($mlminus == 0 || $ml->{value} == 0) : $jumpout > 0) {
#          if ($sweetflag ? ($mlminus == 0 || $ml->{value} == 0) : ($ml->{value} - $mlminus) * ($level % 2 ? -1 : 1) > 0) {
#          if ($jumpout > 0) {
#          if ($sweetflag ? $mlminus == 0 : ($ml->{value} - $mlminus) * ($level % 2 ? -1 : 1) > 0) {
#          if ($sweetflag ? ($mlminus == 0 || $value == 0) : ($ml->{value} - $mlminus) * ($level % 2 ? -1 : 1) > 0) {
#          if ($sweetflag ? ($mlminus == 0 || $value == 0) : ($value - $mlminus) * ($level % 2 ? -1 : 1) > 0) {
#          if ($sweetflag ? 1 == 0 : ($value - $mlminus) * ($level % 2 ? -1 : 1) > 0) {
#          if (($value - $mlminus) * ($level % 2 ? -1 : 1) > 0) {
#          if (($ml->{value} - $mlminus) * ($level % 2 ? -1 : 1) > 0) {
#print Dumper $thischild->{parent}->{value};
          if (defined $thischild->{parent}->{value}) {
#print "value $value \n";
#print "pvalue $thischild->{parent}->{value} \n";
            if (($value - $thischild->{parent}->{value}) * ($level % 2 ? -1 : 1) > 0) {
              $hmm = 0;
              $retval = $thischild->{parent}->{value};
              last;
            }
          }
#        }
      }
    }

#    $retval = handleminimax($curr_node, $sweetflag, $level % 2, @children) if $hmm;
#    $retval = handleminimax($curr_node, $level % 2, $self, @children) if $hmm;
    $retval = handleminimax($curr_node, $level % 2, @children) if $hmm;
  } else {
    $retval = $curr_node->{value};
  }
  return $retval;
}
#=cut

sub minimaxloopwalk {
  my $self = shift;
  $self->{process}->($self->{mnhandle}->{curr_node}, $self->{startflag});
#  my $tracker = {};
#  $process->($curr_node, $sweetflag, $startflag, $tracker);
#  $process->($curr_node, $startflag, $tracker, $self);
#  $process->($curr_node, $startflag, $tracker);
#store $self->{mnhandle}, 'mmh'; # test.pl complex (with all passes) compresses as a .tar.bz2 of ~ 30mb
#store $self->{pathanswers}, 'hash'; # about 1/3 the size as above
#print Dumper $self->{pathanswers};
#$self->{mnhandle} = retrieve('file'); # do this or putintree
  return $self->{mnhandle}->get_data();
}

=cut

=pathanswerspotentialstill
sub handleminimax {
#  my ($curr_node, $minormax, $self, @children) = @_;
  my ($curr_node, $minormax, @children) = @_;
#  my $path = $curr_node->{key};
#  $curr_node->{value} = $children[0]->{value};
#  $curr_node->{key} = $children[0]->{key};
#  shift @children;
#  my $path = $curr_node->{key}; # moving to here and doing pathanswers -> ...

  for (@children) {
 #   my $childvalue = $_->{value};
#    if (defined $childvalue) {
#      if ($minormax ? $childvalue < $curr_node->{value} : $childvalue > $curr_node->{value}) {
#      if ($minormax ? $childvalue < $curr_node->{value} : $childvalue > $curr_node->{value}) {
       setminimaxnodes($curr_node, $_->{value}, $minormax);
#       if ($minormax ? greaterthan($curr_node->{value}, $childvalue) : greaterthan($childvalue, $curr_node->{value})) {
##        my $string = $minormax ? "$minormax: $_->{id} < $curr_node->{id}" : "$minormax: $_->{id} > $curr_node->{id}";
##        my $string = $minormax ? "$minormax: $childvalue < $curr_node->{value}" : "$minormax: $childvalue > $curr_node->{value}";

##print "string is $string\n";
#        $curr_node->{value} = $childvalue;
##        $curr_node->{key} = "$_->{key} ($string)";
#        $curr_node->{key} = $_->{key};
#      } elsif ($childvalue == $curr_node->{value}) {
#        $curr_node->{key} = pack "A*A*", $curr_node->{key}, $_->{key};
##        $curr_node->{key} = pack "A*A*", $curr_node->{key}, $_->{key};
#      }
##      } else {
##        my $string = !$minormax ? "$childvalue < $curr_node->{value}" : "$childvalue > $curr_node->{value}";
##        $curr_node->{key} = "$_->{key} ($string)";
##      }
##    }
  }

## the below creates $self->{pathanswers} which returns a hash of best moves when a path is input
## ~ +2/3 program run ~ -2/3 footprint (once mmhandle discarded although max is higher during run)
## $self->{pathanswers} can be kept and reused
## do here when answer found 
## (redo parameters to add $self)
#  if ($path) {
##print "multikey is $curr_node->{key}\n";
#    for my $key (split "\x01:", $curr_node->{key}) { # root is explicitly mentioned...
##print "key is $key\n";
#      $key = "\x01:$key";
##print "key is $key\n";
##print "path in is $path\n";
#      if ($key =~ /$path(.*)/) {
##print "matched $1\n";
#        (my $move) = split ':', $1;
##  print "found move $move\n";
##        $self->{pathanswers}->{$path}->{$move} = $curr_node->{value} if $move;
#        $self->{pathanswers}->{$path}->{$move} = 1 if $move; # more flexible but lost info # # info can be recovered
#      }
#    }
#  }
#print $curr_node->{id}, " ", $curr_node->{key}, "\n";
## we can compare an answer file to a tree and say same and put note
## we can see rule like is (a, b), (c, d) and have 3 ways, and even one tree rule
## so we can make notes book smaller and say we can place inside
#  return $curr_node->{value};
}

sub handleminimaxadd {
  my ($curr_node, @children) = @_; 

  for (@children) {
    setaddnodes($curr_node, $_->{value});
  }

}

sub handleminimaxsweet {
#  my ($curr_node, undef, @children) = @_; # undef helps when uncommenting sweet plays mean
  my ($curr_node, @children) = @_; 
#  $curr_node->{value} = abs($children[0]->{value}); # abs($curr_node->{value}) this is for throw
#  $curr_node->{key} = $children[0]->{key};
#  shift @children;

  for (@children) {
#    my $childvalue = $_->{value};
    setsweetnodes($curr_node, abs($_->{value}));
##    if (defined $childvalue) {
##      if (abs($childvalue) > $curr_node->{value}) {
#      if (abs($childvalue) < $curr_node->{value}) {
#        $curr_node->{value} = abs($childvalue);
#        $curr_node->{key} = $_->{key};
##      } elsif ($childvalue == $curr_node->{value}) { # gives good answer
#      } elsif (abs($childvalue) == $curr_node->{value}) {
##        $curr_node->{key} .= "\0$_->{key}";
#        $curr_node->{key} = pack "A*A*", $curr_node->{key}, $_->{key};
#      }
#    }
  }

#  return $curr_node->{value}; # postprocessquicker needs these (?) # postprocessquicker out of order
}
=cut

sub setminimaxnodes {
  my ($curr_node, $childvalue, $minormax) = @_;
  if ($minormax ? $curr_node->{value} > $childvalue : $childvalue > $curr_node->{value}) {
    $curr_node->{value} = $childvalue;
    $curr_node->{key} = $_->{key};
  } elsif ($childvalue == $curr_node->{value}) {
    $curr_node->{key} = pack "A*A*", $curr_node->{key}, $_->{key};
  }
}

sub setsweetnodes {
  my ($curr_node, $childvalue) = @_;
  if ($curr_node->{value} > $childvalue) {
    $curr_node->{value} = $childvalue;
    $curr_node->{key} = $_->{key};
  } elsif ($childvalue == $curr_node->{value}) {
    $curr_node->{key} = pack "A*A*", $curr_node->{key}, $_->{key};
  }
}

sub setaddnodes {
  my ($curr_node, $childvalue) = @_;
  if ($childvalue > $curr_node->{value}) {
    $curr_node->{value} = $childvalue;
    $curr_node->{key} = $_->{key};
  } elsif ($childvalue == $curr_node->{value}) {
    $curr_node->{key} = pack "A*A*", $curr_node->{key}, $_->{key};
  }
}

sub setspmnodes {
  my ($curr_node, $childvalue, $minormax) = @_;
  if ($minormax ? abs($childvalue) < abs($curr_node->{value}) : $childvalue > $curr_node->{value}) {
    $curr_node->{value} = ($minormax ? abs($childvalue) : $childvalue);
    $curr_node->{key} = $_->{key};
  } elsif ($minormax ? abs($childvalue) == abs($curr_node->{value}) : $childvalue == $curr_node->{value}) {
    $curr_node->{key} = pack "A*A*", $curr_node->{key}, $_->{key};
  }
}

sub analysetree {
#sub cleanup { # move to BimaryishTrees hampered by misc routines
  my $self = shift;
  $self->{process}->($self->{mnhandle}->{curr_node}, $self->{startflag});
  my ($bp, $bv) = $self->{mnhandle}->get_data();
#  my ($bp, $bv, $root) = @_;
#  my ($bp, $bv, $self->{root}) = @_;
#  my @ks = map { droproot($_) } split "\0", $bp;
  my @ks = split "$self->{root}:", $bp;
  shift @ks; # split finds something before first root
  return $self, $bv, \@ks;
}


=scruffy sweet plays mean
sub handleminimax {
  my ($curr_node, $minormax, @children) = @_;
#  $curr_node->{value} = $sweetflag ? abs($children[0]->{value}) : $children[0]->{value};
  $curr_node->{value} = ($minormax ? abs($children[0]->{value}) : $children[0]->{value});
#print "curr_node ", $curr_node->{value}, "\n";
  $curr_node->{key} = $children[0]->{key};
  shift @children;

  for (@children) {
    my $childvalue = $_->{value};
    if (defined $childvalue) {
#      if ($sweetflag ? abs($childvalue) < abs($curr_node->{value}) : ($minormax ? $childvalue < $curr_node->{value} : $childvalue > $curr_node->{value})) {
      if (($minormax ? abs($childvalue) < abs($curr_node->{value}) : $childvalue > $curr_node->{value})) {

#      if ($sweetflag ? abs($childvalue) < abs($curr_node->{value}) : abs($childvalue) > abs($curr_node->{value})) {
#      if ($sweetflag ? abs($childvalue) < abs($curr_node->{value}) : ($minormax ? $childvalue > $curr_node->{value} : $childvalue < $curr_node->{value})) {
#        $curr_node->{value} = $childvalue;
#        $curr_node->{value} = $sweetflag ? abs($childvalue) : $childvalue;
#        $curr_node->{value} = $sweetflag ? abs($childvalue) : abs $childvalue;
#        $curr_node->{value} = $sweetflag ? abs($childvalue) : $childvalue;
        $curr_node->{value} = ($minormax ? abs($childvalue) : $childvalue);
        $curr_node->{key} = $_->{key};
#      } elsif ($childvalue == $curr_node->{value}) { # gives good answer
      } elsif (($minormax ? abs($childvalue) == abs($curr_node->{value}) : $childvalue == $curr_node->{value})) {
#      } elsif ($sweetflagplus ? abs($childvalue) == abs($curr_node->{value}) : $childvalue == $curr_node->{value}) {
        $curr_node->{key} .= "\0$_->{key}";
      }
    }
  }

  return $curr_node->{value};
}
=cut
1;
