package Games::BinaryishTrees::pairs;

use strict;
use warnings;
use Carp qw(croak carp cluck);
#use Games::BinaryishTrees::messages qw(message messagewithvariable messageadd messageaddsimple);
use Games::BinaryishTrees::messages qw(message);
use Games::BinaryishTrees::utils qw(indexof);
#use Data::Dumper;
#use Data::Printer;
#use Storable;
require Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = qw(pair option deletepair deleteoption checkpairs _pookpair listpairs listoptions _pair);

sub checkpairs {
  my $self = shift;
  checkleftright($self->{pairs});
  checkids($self, @{$self->{trees}});
#print Dumper $self->{options};
  checkoptions($self);
#print Dumper $self->{options}; # 1 & -1 keys added ...
#  checkfortwigless($self); # moved croak later
  recursivepookcheck($self, $self->{pairs});
}

sub pair {
  my $self = shift;
  my $id = shift;
  my @ps = @_;
#  if (ref($ps[-1]) eq "ARRAY") {
#    pop @ps;
#    $aref = my pop @ps;
#    my $aref = pop @ps;
##    $aref = my pop @ps;
#    push @ps, @{$ps};
#    push @ps, @{$aref};
#  }
#print join "\n", @ps;
#  checkfortwigless(@_);
#  idcheck(@ps);
#  checkid($ps[0], $ps[1]);
#  checkid($self, $ps[0]);
  checkid($self, $id);
#  _pair(@ps);
#  _pair($ps[0], \@ps);
#  _pair($self, \@ps);
  _pair($self, $id, \@ps, 0);
  return {$id => $self->{pairs}->{$id}};
}

sub _pookpair {
  my ($self, $id, $aref) = @_;
#print "pooking\n";
  _pair($self, $id, $aref, 1);
}

sub _pair { # perl sees "1" and 1 as equal, so [$lstring, $rstring, $triggerhash] better to check sense
#  my ($self, $id, $left, $right, $lstring, $rstring, $triggerhash, $ispook) = @_;
#  my ($self, $aref, $ispook) = @_;
#  my ($id, $left, $right, $lstring, $rstring, $triggerhash) = @$aref;
  my ($self, $id, $aref, $ispook) = @_;
#  my ($left, $right, $lstring, $rstring, $triggerhash) = @$aref;
  my $left = $aref->[0];
  my $right = $aref->[1];
#print "id is $id\n"; # a pook can't be undef -> it becomes the string undef
#print "lstring is $lstring\n";
#store $self->{pairs}, 'filelessdumper'; # hmm code items in $self
#$self->{mnhandle} = retrieve('file');
#my %selfhash = %{$self->{pairs}};
#print Dumper \%selfhash;
#cluck; # solve is continually called (!)
#print Dumper $self->{pairs}; # makes (?) neverending loop with dumperloop.pl <!-- pookwarnings stuck on 'w' --> -> see oddone #  (?) break anything it stops
#print Dumper {$self->{pairs} => 1}; # works ?, looks into Data::Dumper doc ...
#print Dumper $self->{pairs}; # fixed using "for keys" loop in solver instead of "while each" loop, bug ticket created in Data::Dumper https://rt.cpan.org/Public/Bug/Display.html?id=127309
  my ($errortype, $errormessage) = redefinedcheck($self, $id, $ispook);
#  croak message(19) if !defined $id;
#  croak messagewithvariable(2, $id) if $id !~ /^[a-zA-Z]/ || $id eq 'P' || $id =~ /:/;
#  croak messageaddsimple(message(32), $id, message(33));
#  croak messageaddsimple(message(32), $id, message(33)) if $id !~ /^[a-zA-Z]/ || $id eq 'P' || $id =~ /:/;
#  croak messageaddsimple(message(34), $id, message(35)) if $id !~ /^[a-zA-Z]/ || $id eq 'P' || $id =~ /:/;
#  croak message(29, $id) if $id !~ /^[a-zA-Z]/ || $id eq 'P' || $id =~ /:/;
#  carp messagewithvariable(3, $id) if exists $self->{pairs}->{$id} && !$self->{warningsoffflag};
#  carp messageaddsimple(message(34), $id, message(35)) if exists $self->{pairs}->{$id} && !$self->{warningsoffflag};
#  carp messageaddsimple(message(36), $id, message(37)) if exists $self->{pairs}->{$id} && !$self->{warningsoffflag};
#  carp message(30, $id) if exists $self->{pairs}->{$id} && !$self->{warningsoffflag};
#  if (checkpairvalue($self, $left, "left") + checkpairvalue($self, $right, "right") == 2) {
  if (checkpairvalue($self, $left, message(50)) && checkpairvalue($self, $right, message(49))) {
    $self->{twigless}->{$id} = $left + $right;
#print "is twigless $id\n";
    # define these now because the twigless code bypasses _play
    # (we don't know if loopflag is set so we can only do twigless)
#    my $plural = $left == 1 ? '' : message(22);
#    $lstring = message(26, $id, $left, $plural) unless defined $lstring;
#    $lstring = message(26, message(50), $id, $left, $plural) unless defined $lstring;
#    $lstring = message(26, message(56), $id, $left, $plural) unless defined $lstring;
#     $lstring = messageaddsimple(message(27), $id, message(28), $left, message(29), $plural, message(30)) unless defined $lstring;
#     $lstring = messageaddsimple(message(12), $id, message(17), $left, message(), $plural, message()) unless defined $lstring;
#     $lstring = messageadd(message(12), $id, message(17), $left, message(), $plural, message()) unless defined $lstring;
#     $lstring = messageadd(message(12), $id, message(17), $left).$plural unless defined $lstring;
#    $lstring = messagewithvariable(12, $id).messagewithvariable(17, $left).$plural unless defined $lstring;
#    $lstring = "left plays $id ($left point$plural)" unless defined $lstring;
#    $lstring = messagewithvariable(12, $id, $left, $plural) unless defined $lstring;
    # to avoid -0
#    $plural = $right == -1 ? '' : message(22);
#    $rstring = join '', "right plays $id (", -$right, " point$plural)" unless defined $rstring;
#    $rstring = messagewithvariable(13, $id, -$right, $plural) unless defined $rstring;
#    $rstring = messagewithvariable(13, $id).messagewithvariable(17, -$right).$plural unless defined $rstring;
#    $rstring = message(27, $id, -$right, $plural) unless defined $rstring;
#    $rstring = message(26, message(49), $id, -$right, $plural) unless defined $rstring;
#    $rstring = message(27, message(55), $id, -$right, $plural) unless defined $rstring
  } else {
#    delete $self->{twigless}; # should onlbe thy exist if this is a redefinition
    delete $self->{twigless}->{$id}; # pooks can change twiglessness 
  }
#  $self->{pairs}->{$id} = [$left, $right, $lstring, $rstring, $triggerhash]; # safe and too many undefs
#  my @array = ($left, $right, $lstring, $rstring, $triggerhash); # see clone.pl for risks of other way
  my @array = @$aref; # see clone.pl for risks of other way # ah
#p @array;
#  if (!defined $aref->[4]) {
#    pop @array;
#    if (!defined $aref->[3]) {
#      pop @array;
#      if (!defined $aref->[2]) {
#        pop @array;
#      }
#    }
#  }

#p @array;
  $self->{pairs}->{$id} = \@array;

#  $self->{pairs}->{$id} = [$left, $right];
#  $self->{pairs}->{$id}->[2] = $lstring if defined $lstring;
#  $self->{pairs}->{$id}->[3] = $rstring if defined $rstring;
#  if (defined $triggerhash) {
#    if (ref $triggerhash ne 'HASH') {
#      croak message(64);
#    }
#  }

  return $errortype, $errormessage;
}

=donewith
sub idcheck {
  my $self = shift;

  for my $id (keys %{$self->{pairs}}) {
    checkid($self, $id);
#print "checked $id\n";
  }

}
=cut

sub recursivepookcheck {
  my ($self, $pairs) = @_;
  $Carp::CarpLevel = 3;
#print "pairs is ", ref \$pairs, "\n";
#  if (ref $pairs eq 'HASH') {

#    while (my ($id, $v) = each %{$pairs}) {
    for my $id (keys %{$pairs}) {
#print "checking $id\n";
      my $v = $pairs->{$id};
      docarpandcroak($self, $v, $id);
  #    if (exists $pairs->{$id}->[4]) {
#p $v->[4];
      if (defined $v->[4]) {
#        if (ref $v->[4] eq 'HASH') {

#          while (my ($k, $v1) = each %{$v->[4]}) {
#          for my $k (keys %{$v->[4]}) {
    #print "checking $k\n";
#print "pairs id is ", ref \$v1->[4], "\n";
#print "pairs id v1 4 is", $v1->[4], "\n";
#            my $v1 = $v->[4]->{$k};
#            docarpandcroak($self, $v, $k);
            if (ref $v->[4] eq 'HASH') {
              recursivepookcheck($self, $v->[4])
            } else {
              croak message(64);# if ref $v->[4];
#          print Dumper $pairs;
            }
          }

#        } else {
#          croak message(64);
#        }
      }
#    }

#  } else {
##    croak message(64) if ref $pairs;
#print Dumper $pairs;
#  }
  $Carp::CarpLevel = 0;
}

sub docarpandcroak {
  my ($self, $v, $id) = @_;
  my $message = checkthisleftright($self->{pairs}, $v, 0);
  $message .= checkthisleftright($self->{pairs}, $v, 1);
  croak $message if $message;
  if (!$self->{warningsoffflag}) {
    $message = message(63, $id) if !exists $self->{pairs}->{$id};
    carp $message if $message;
  }
}

=back into _pair
sub checkfortwigless {
  my ($self, $id, $left, $right) = @_;

  if (checkpairvalue($self, $left, message(50)) + checkpairvalue($self, $right, message(49)) == 2) {
    $self->{twigless}->{$id} = $left + $right;
  }

}
=cut

=moved croak later
sub checkfortwigless {
  my $self = shift;

  for my $id (keys %{$self->{pairs}}) {
    my $left = $self->{pairs}->{$id}->[0];
    my $right = $self->{pairs}->{$id}->[1];
    if (checkpairvalue($self, $left, message(50)) + checkpairvalue($self, $right, message(49)) == 2) {
      $self->{twigless}->{$id} = $left + $right;
    }
  }
}
=cut

sub redefinedcheck() {
  my ($self, $id, $ispook) = @_;
#print "$id, $ispook\n";
  my ($errortype, $errormessage) = (0, '');
  if (!$self->{warningsoffflag} && exists $self->{pairs}->{$id}) {
    if ($ispook) {
      ($errortype, $errormessage) = (2, message(30, $id)); 
    } else {
      carp message(30, $id);
    }
  }
  return $errortype, $errormessage;
#  carp message(30, $id) if exists $self->{pairs}->{$id} && !$self->{warningsoffflag};
}

sub checkid {
  my ($self, $id) = @_;
  my ($errortype, $errormessage) = (0, '');
  if (!defined $id) {
    croak message(19);
  }
#  if ($id !~ /^[a-zA-Z]/ || $id eq 'P' || $id =~ /:/) {
#  if ($id !~ /^[a-zA-Z]/ || $id eq 'P' || $id =~ /:/ || $id eq message(51) || $id eq message(16)) {
#    croak message(29, $id);
#  }
  croak message(29, $id) if $id !~ /^[a-zA-Z]/ || $id =~ /:/;
  croak message(69, $id) if $id eq 'P' || $id eq message(51) || $id eq message(16);
#  croak message(19) if !defined $id;
#  croak message(29, $id) if $id !~ /^[a-zA-Z]/ || $id eq 'P' || $id =~ /:/;
  return $errortype, $errormessage;
}

sub checkpairvalue {
  my ($self, $value, $LRstring) = @_;
  my $isint = 0;
#  croak messagewithvariable(4, $LRstring) if !defined $value;
#  croak messageaddsimple(message(36), $LRstring, message(37)) if !defined $value;
#  croak messageaddsimple(message(38), $LRstring) if !defined $value;
  croak message(31, $LRstring) if !defined $value;
  if ($value =~ /^-?\d+$/) {
    $isint = 1;
  } elsif ($value !~ /^[a-zA-Z]/) {
#    croak messagewithvariable(5, $value);
#    croak messageaddsimple(message(39), $value, message(40));
    croak message(32, $value);
  }
  return $isint;
}

#paste in old checkpairvalue and rename
##sub oldcheckpairvalue {
#  my ($self, $value, $LRstring) = @_;
#  my $isint = 0;
#  croak "$LRstring value not defined" if !defined $value;
#  if ($value =~ /^-?\d+$/) {
#    $isint = 1;
#  } elsif ($value !~ /^[a-zA-Z]/) {
#    croak "'$value' not recognised";
#  }
#  return $isint;
#}
## this is not new way with verybraze hat on (haton or hat on?)

sub option {
  my ($self, $rightorleft, $id, @options) = @_;
#  croak "first parameter to options must be 'left' or 'right' (got $rightorleft)" unless $rightorleft eq 'left' || $rightorleft eq 'right';
#  croak messagewithvariable(6, $rightorleft) unless $rightorleft eq 'left' || $rightorleft eq 'right';
#  croak messagewithvariable(message(41), $rightorleft, message(42)) unless $rightorleft eq 'left' || $rightorleft eq 'right';
  croak message(33, message(49), message(50), $rightorleft) unless $rightorleft eq message(49) || $rightorleft eq message(50);
  croak message(20) unless @options;
#  $self->{options}->{$rightorleft eq 'left' ? 1 : -1}->{$id} = \@options;
#  $self->{options}->{$rightorleft eq message(69) ? -1 : 1}->{$id} = \@options;
  $self->{options}->{$rightorleft eq message(49) ? -1 : 1}->{$id} = \@options; # (50 is left)
}

sub listoptions {
  my $self = shift;
  return $self->{options};
}

sub checkoptions {
  checkoptionsLR($_[0], '1');
#print Dumper $_[0]->{options}; # 1 added
  checkoptionsLR($_[0], '-1');
}

sub checkoptionsLR {
  my ($self, $toggle) = @_;
#print Dumper $self->{options};
#  my @idlist = keys %{$self->{options}->{$toggle}}; 
#print Dumper $self->{options}; # 1 added
  my @idlist;
#  my @idlist = keys %{$self->{options}->{$toggle}} if exists $self->{options}->{$toggle};
  @idlist = keys %{$self->{options}->{$toggle}} if exists $self->{options}->{$toggle};
  checkids($self, @idlist);
  my $emessage = '';

  for my $id (@idlist) {

    for my $option (@{$self->{options}->{$toggle}->{$id}}) {
#      $emessage .= "id $option not defined" if !exists $self->{pairs}->{$option};
#      $emessage .= messagewithvariable(7, $option) if !exists $self->{pairs}->{$option};
#      $emessage .= messageaddsimple(message(43), $option, message(44)) if !exists $self->{pairs}->{$option};
      $emessage .= message(34, $option) if !exists $self->{pairs}->{$option};
    }

  }

  croak $emessage if $emessage;
}

sub checkleftright {
  my $pairs = shift;
  my $emessage = '';

  for my $v (values %{$pairs}) {
#    $emessage .= "id $v->[0] not defined" if $v->[0] !~ /^-?\d+$/ && !exists $pairs->{$v->[0]};
#    $emessage .= messagewithvariable(7, $v->[0]) if $v->[0] !~ /^-?\d+$/ && !exists $pairs->{$v->[0]};
#    $emessage .= messagewithvariable(message(43), $v->[0], message(44)) if $v->[0] !~ /^-?\d+$/ && !exists $pairs->{$v->[0]};
#    $emessage .= messageaddsimple(message(43), $v->[0], message(44)) if $v->[0] !~ /^-?\d+$/ && !exists $pairs->{$v->[0]};
#    $emessage .= message(34, $v->[0]) if $v->[0] !~ /^-?\d+$/ && !exists $pairs->{$v->[0]};
    $emessage .= checkthisleftright($pairs, $v, 0);
#    $emessage .= "id $v->[1] not defined" if $v->[1] !~ /^-?\d+$/ && !exists $pairs->{$v->[1]};
#    $emessage .= messagewithvariable(7, $v->[1]) if $v->[1] !~ /^-?\d+$/ && !exists $pairs->{$v->[1]};
#    $emessage .= messagewithvariable(message(43), $v->[1], message(44)) if $v->[1] !~ /^-?\d+$/ && !exists $pairs->{$v->[1]};
#    $emessage .= messageaddsimple(message(43), $v->[1], message(44)) if $v->[1] !~ /^-?\d+$/ && !exists $pairs->{$v->[1]};
#    $emessage .= message(34, $v->[1]) if $v->[1] !~ /^-?\d+$/ && !exists $pairs->{$v->[1]};
    $emessage .= checkthisleftright($pairs, $v, 1);
  }

  croak $emessage if $emessage;
}

sub checkthisleftright {
  my ($pairs, $v, $toggle) = @_;
  if ($v->[$toggle] !~ /^-?\d+$/ && !exists $pairs->{$v->[$toggle]}) {
    return message(34, $v->[$toggle]);
  }
  return '';
}

=oddone
sub checkthisleftright {
  my ($pairs, $v, $toggle) = @_;
#  return undef; # (uncomment oddone) and ((comment or uncomment) this line) and uncomment print Dumper in _pair
# returning a number is ok ('my' line evaluates to 1)
}
=cut

sub checkids {
  my ($self, @idlist) = @_;
  my $emessage = '';

  for my $id (@idlist) {
#    $emessage .= "id $id not defined" if !exists $self->{pairs}->{$id};
#    $emessage .= messagewithvariable(7, $id) if !exists $self->{pairs}->{$id};
#    $emessage .= messagewithvariable(message(43), $id, message(44)) if !exists $self->{pairs}->{$id};
# search for messagewithvariable too many
#    $emessage .= messageaddsimple(message(43), $id, message(44)) if !exists $self->{pairs}->{$id};
    $emessage .= message(34, $id) if !exists $self->{pairs}->{$id};
  }

  croak $emessage if $emessage;
}

sub deleteoption { # maybe this is too complex
  my ($self, $rightorleft, $id, @options) = @_;
#  croak "first parameter to deleteoption must be 'left' or 'right' (got $rightorleft)" unless $rightorleft eq 'left' || $rightorleft eq 'right';
#  croak messagewithvariable(8, $rightorleft) unless $rightorleft eq 'left' || $rightorleft eq 'right';
#  croak messageaddsimple(message(45), $rightorleft, message(46)) unless $rightorleft eq 'left' || $rightorleft eq 'right';
  if (defined $rightorleft) {
    croak message(35, message(49), message(50), $rightorleft) unless $rightorleft eq message(49) || $rightorleft eq message(50);
  #  croak messageaddsimple(message(45), $rightorleft, message(46)) unless $rightorleft eq message(70) || $rightorleft eq message(69);
    croak message(21) unless defined $id;
  #  my $toggle = $rightorleft eq 'left' ? 1 : -1;
    my $toggle = $rightorleft eq message(49) ? -1 : 1;
    my $option = $self->{options}->{$toggle}->{$id};
    if (defined $option) {
      if (@options) {
        my @options_set = @{$self->{options}->{$toggle}->{$id}};

        for (@options) {
          my $index = indexof($_, @options_set);
          if (defined $index) { 
            splice @options_set, $index, 1;
          } else {
  #          carp "could not delete $_ (not found)" unless $self->{warningsoffflag};
  #          carp messagewithvariable(9, $_) unless $self->{warningsoffflag};
  #          messageadd(message(25), $_, message(26)) unless $self->{warningsoffflag};
  #          messageaddsimple(message(52), $_, message(53)) unless $self->{warningsoffflag};
            message(25, $_) unless $self->{warningsoffflag}; # todo - is $_ defined ?
          }
        }

        if (@options_set) {
          $self->{options}->{$toggle}->{$id} = \@options_set;
        } else {
          delete $self->{options}->{$toggle}->{$id};
        }
      } else {
        delete $self->{options}->{$toggle}->{$id};
      }
    } else {
  #    croak "option $rightorleft $id not found";
  #    croak messagewithvariable(11, $rightorleft, $id);
  #    croak messagewithvariable(11, $rightorleft).messagewithvariable(16, $id);
  #    croak messageaddsimple(47, $rightorleft, message(48), $id, message(49));
  #    croak messageaddsimple(message(47), $rightorleft, message(48), $id, message(49));
      croak message(36, $rightorleft, $id);
    }
    return $self->{options}->{$toggle}->{$id};
  } else {
    $self->{options} = {};
    return undef;
  }
}

sub deletepair {
  my ($self, $id) = @_;
  if (defined $id) {
#    my $pair = $self->{pairs}->{$id};
    if (exists $self->{pairs}->{$id}) {
#    if (defined $pair) {
      delete $self->{pairs}->{$id};
      delete $self->{twigless}->{$id};
    } else {
#      croak "pair $id not found";
#      croak messagewithvariable(10, $id);
#      croak messageaddsimple(message(50), $id, message(51));
      croak message(37, $id);
    }
  } else {
    $self->{pairs} = {};
    $self->{twigless} = {};
  }
  return 1;
}

#sub listpairs {
#  my $self = shift;
#  my $view = {};
#
#  for my $k (keys %{$self->{pairs}}) {
#    $view->{$k} = 1;
#  }
#
#  return $view;
#}

sub listpairs {
  my $self = shift;
  return $self->{pairs};
}

1;
