package Games::BinaryishTrees::solver;

use strict;
use warnings;
use Games::BinaryishTrees::mnTree;
use Games::BinaryishTrees::init qw(initsolve findkos findpoortrees);
use Games::BinaryishTrees::twigless qw(optleaves permleaves);
use Games::BinaryishTrees::pairs qw(pair _pookpair);
use Games::BinaryishTrees::messages qw(message);
use Carp;
#use Data::Dumper;
#use Data::Printer;
require Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = qw(_solve _play);

sub _solve {
  my ($gbt, @params) = @_;
#  my $gbt = shift;
#  my ($gbt, $treeref, @params) = @_;
#  if (ref($gbt) eq 'ARRAY') {
#print ref $gbt, "\n";
#  if (ref($gbt) eq 'HASH') {
#  if (ref($gbt) eq 'Games::BinaryishTrees') {
#  $Carp::CarpLevel = 2;
#  croak message(47) if ref($gbt) ne 'Games::BinaryishTrees';
#  my $treeref = shift;
#  croak message(17) if ref($treeref) ne 'ARRAY';
#  my @trees = @{$treeref};
#  croak message(18) if !@trees;
#  $Carp::CarpLevel = 0;

#  $gbt->setparams(@params) if @params;

#    $gbt->{leafprocess} = $gbt->{processflag} ? \&optleaves : \&permleaves;
#  $gbt->{leafprocess} = $gbt->{sweetflag} ? \&permleaves : $gbt->{processflag}  ? \&optleaves : \&permleaves;
#  my $sflag = defined($gbt->{strategyvalue}) && $gbt->{strategyvalue} == 2 ? 1 : 0;
#  my $optsflag = defined($gbt->{strategyvalue} && $gbt->{strategyvalue} != 2 ? 1 : 0;
#  my $optsflag = (not defined $gbt->{strategyvalue}) || $gbt->{strategyvalue} == 0 ? 1 : 0;
#print "optsflag is $optsflag\n";
#print "stv is ", $gbt->{strategyvalue}, "\n";
#  $gbt->{leafprocess} = $gbt->{sweetflag} ? \&permleaves : $gbt->{processflag} && $optsflag ? \&optleaves : \&permleaves;
  $gbt->{leafprocess} = setupleafprocess($gbt);
#  $gbt->{leafprocess} = $gbt->{sweetflag} ? \&permleaves : $gbt->{processflag} && $gbt->{strategyvalue} != 2 ? \&optleaves : \&permleaves;
#  $gbt->{leafprocess} = $gbt->{sweetflag} ? \&permleaves : \&optleaves;
#  initsolve($gbt, \@trees);
  initsolve($gbt);
#  initsolve($gbt, $treeref)
#  initsolve($gbt, $treeref);
#print Dumper $gbt->{kos};
#if ($gbt->{sweetflag} && $gbt->{passflag} && $gbt->{passplusflag}) {
##  $gbt->{leaves}->{'z:P'} = 0; bailout gbt_isok.pl check
#  $gbt->{leaves}->{'P:P'} = 0;
#} else {
#p $gbt->{trees};
  my $sflag = defined($gbt->{strategyvalue}) && $gbt->{strategyvalue} == 2 ? 1 : 0;
#print "starting history is\n";
#print Dumper $gbt->{history};
  onemove($gbt, $gbt->{startflag} ? -1 : 1, $gbt->{root}, 0, $sflag, sort @{$gbt->{trees}});
#p $gbt->{leaves};
#}
#croak; # to see ~ 20% storage here
#print Dumper $gbt->{forcedpasses};
#  return Games::BinaryishTrees::mnTree->new($gbt->{processflag}, $gbt->{startflag}, $gbt->{leaves}, $gbt->{sweetflag}, $gbt->{root});
#  return Games::BinaryishTrees::mnTree->new($gbt->{startflag}, $gbt->{leaves}, $gbt->{sweetflag}, $gbt->{root}, $gbt->{strategyvalue});
#  } else {
#    message(67); croak message(67);
#    croak message(47);
#  }

  if (!%{$gbt->{leaves}}) {
    $gbt->{leaves}->{"$gbt->{root}:P:P"} = 0;
  }
#p $gbt->{leaves};
  return Games::BinaryishTrees::mnTree->new($gbt->{startflag}, $gbt->{leaves}, $gbt->{sweetflag}, $gbt->{root}, $gbt->{strategyvalue});
}

=comment
sub _solve {
  my $gbt = shift;
  if (ref($gbt) eq 'ARRAY') }
  my $treeref = shift;
  $gbt->setparams(@_) if @_;
  $gbt->{leafprocess} = $gbt->{processflag} ? \&optleaves : \&permleaves;
  initsolve($gbt, $treeref);
  onemove($gbt, join('', @{$gbt->{trees}}), $gbt->{startflag} ? -1 : 1, $gbt->{root}, 0, 0, @{$gbt->{trees}});
  return Games::BinaryishTrees::mnTree->new($gbt->{processflag}, $gbt->{startflag}, $gbt->{leaves}, $gbt->{sweetflag});
  }
}
=cut

sub onemove {
#  my ($gbt, $lastid, $toggle, $path, $lastmoveP, $lastscore, @tree) = @_;
  my ($gbt, $toggle, $path, $lastscore, $sflag, @tree) = @_;
# for differing strategies, $rsflag and $lsflag, 2 $gbt->{leafprocess}es, multiple mnTree minimaxers, (reusabe with setstart - tricky from here with strategy 2) 
#print "($path)\n";
#  if (!$gbt->{passflag} && !$gbt->{passplusflag} && @tree > 1 && alltwigless($gbt, @tree)) { # careful with the distinction
  if (!$gbt->{passflag} && @tree > 1 && alltwigless($gbt, @tree)) {
    $gbt->{leafprocess}->($gbt, $path, $lastscore, $toggle, $sflag, @tree);
  } else {
    my $doneP = 0; # a flag to avoid considering 'pass' more than once 
    my $lastmoveP = substr($path, -1) eq 'P';

    for my $index (-$gbt->{passflag}..$#tree) { # we need $index to splice @tree in the right place
      my @options;
      if ($index == -1) {
        if ($gbt->{passplusflag}){# && !$gbt->{sweetflag}) {
          if (allpp($gbt->{pp}, @tree)) {
#            next;
            push @options, 'P';
          } else {
            next;
#           push @options, 'P';
          }
        } else {
          push @options, 'P';
        }
        if ($lastmoveP) {
          if ($sflag) {
#            $gbt->{leaves}->{"$path:P"} = $lastscore + ($gbt->{lmbflag} + $gbt->{passtaxflag}); # compensate for previous -1
            $gbt->{leaves}->{"$path:P"} = $lastscore - $gbt->{lmbflag} + $gbt->{passtaxflag};
          } else {
            $gbt->{leaves}->{"$path:P"} = $lastscore + ($gbt->{lmbflag} - $gbt->{passtaxflag}) * $toggle;
          }
          next;
        }
      } else {
        push @options, $tree[$index];
        if (exists $gbt->{options}->{$toggle} && exists $gbt->{options}->{$toggle}->{$tree[$index]}) {
          my $o = $gbt->{options}->{$toggle}->{$tree[$index]};
          push @options, @{$o};# if defined $o;
        }
      }
			my $outertreeid = join ':', sort @tree;

      for my $move (@options) {
        my ($treeid, $allow, $newscore, $cloned, @treecopy) = (undef, 1, 0, undef, @tree);
        my $moveisP = $move eq 'P';
        if ($moveisP) {
#          $treeid = join '', sort @treecopy;
#          $treeid = join ':', sort @treecopy;
          $treeid = $outertreeid;
        } else {
          ($treecopy[$index], $newscore, undef, $cloned) = _play($gbt, $toggle, $move, undef, $sflag);
          splice @treecopy, $index, 1 unless $treecopy[$index];
          if (@treecopy) {
            $treeid = join ':', sort @treecopy;
#            if (exists $gbt->{history}->{$treeid}) {
#              $allow = !$doneP && ($gbt->{passflag} || forcedpass($gbt, $index, $toggle, @tree));
#              ($moveisP, $newscore, $move, @treecopy) = (1, 0, 'P', @tree) if $allow;
#            }
#if (0) {
            if (exists $gbt->{history}->{$treeid}) {
#print "path is $path, treeid is $treeid\n";
#print Dumper $gbt->{history};

              $allow = !$doneP && $gbt->{passflag};
#              $allow = !$doneP && ($gbt->{passflag} || $forcedpass);
#              ($moveisP, $newscore, $move, @treecopy) = (1, 0, 'P', @tree) if $allow;
              if ($allow) {
                ($moveisP, $newscore, $move, @treecopy) = (1, 0, 'P', @tree);
              } else {
#                my $forcedpass = forcedpass($gbt, $index, $toggle, @tree);
  #              if ($forcedpass) {
#                if (!$forcedpass) { # programming ? just type zeroes and ones it'll be right soon enough
  #                push @{$gbt->{forcedpasses}->{$path}}, $treecopy[$index]; # hmm lots of these # (looked and found some)
#                $gbt->{forcedpasses}->{$path}->{$move} = 1;
#                $gbt->{pathrepeat}->{$path}->{$move} = 1; # 2% slower for allchoices # (see Options)
#print "$path $move $doneP\n";
#                }
                if (!$doneP) {
#print "path is $path\n";
#print join(':', @tree), "\n";
                  $allow = forcedpass($gbt, $index, $toggle, @tree);
                  if ($allow) {
                    ($moveisP, $newscore, $move, @treecopy) = (1, 0, 'P', @tree);
                  }
                }
              }
            }
          }
#}
        }
        if ($allow) {
          if ($sflag) {
            $newscore += $lastscore + ($gbt->{lmbflag} ? 1 : 0);
          } else {
            $newscore += $lastscore + ($gbt->{lmbflag} ? $toggle : 0);
          }
#          $newscore += $lastscore + ($gbt->{lmbflag} ? $toggle : 0);
          if (defined $treeid) {
            $doneP = $moveisP;
            $gbt->{history}->{$treeid} = 1 unless $moveisP; # .
            unless ($lastmoveP && $moveisP) { # some small test language (careful now with .)
              if ($sflag) {
#print "$path, $moveisP, $newscore";
                $newscore += - ($gbt->{passtaxflag} && $moveisP ? 1 : 0);
#print " $newscore\n";
              } else {
                $newscore += - ($gbt->{passtaxflag} && $moveisP ? $toggle : 0);
              }
              onemove($gbt, -$toggle, "$path:$move", $newscore, $sflag, @treecopy);
            }
            unless ($moveisP) {
              delete $gbt->{history}->{$treeid};
            }

          } else {
            $gbt->{leaves}->{join ':', $path, $move, 'P', 'P'} = $newscore;
          }
          extractcloned($gbt, $cloned) if defined $cloned;
        }

      }

    }

  }
       
}

sub setupleafprocess {
	my $gbt = shift;
	my $process = \&permleaves;
	if ($gbt->{processflag}) {
		if (defined $gbt->{strategyvalue}) {
			$process = \&optleaves if $gbt->{strategyvalue} == 0;
		} else {
			$process = \&optleaves if $gbt->{sweetflag} == 0;
		}
	}
	return $process;
}

=scruffyone
sub onemove {
  my ($gbt, $lastid, $toggle, $path, $lastmoveP, $lastscore, @tree) = @_;
#print "($path)\n";
#print join('~', @tree), "\n";
#print "history at onemove start is\n";
#print Dumper $gbt->{history};
#  if (!$gbt->{passflag} && @tree > 1 && alltwigless($gbt->{twigless}, $gbt->{options}, @tree)) {
#  my $gbtclone = clone($gbt);
#  if (!$gbt->{passflag} && @tree > 1 && alltwigless($gbt->{twigless}, $gbt->{options}, @tree)) {
  if (!$gbt->{passflag} && @tree > 1 && alltwigless($gbt, @tree)) {
    $gbt->{leafprocess}->($gbt, $path, $lastscore, $toggle, @tree);
#print Dumper $gbt->{pairs}->{c}->[0];
  } else {
    my $doneP = 0; # a flag to avoid considering 'pass' more than once 

    for my $index (-$gbt->{passflag}..$#tree) { # we need $index to splice @tree in the right place
      my @options;
      if ($index == -1) {
#print "lastmoveP is $lastmoveP\n";
#        next unless $gbt->{passplusflag} || allpp($gbt->{pp}, @tree);
        if ($gbt->{passplusflag} && allpp($gbt->{pp}, @tree)) {
          next;
        } else {
          if ($lastmoveP) {
            $gbt->{leaves}->{"$path:P"} = $lastscore + ($gbt->{lmbflag} - $gbt->{passtaxflag}) * $toggle;
            next;
          }
          push @options, 'P';
#print Dumper @options;
#print $gbt->{passflag}, "\n";
        }
      } else {
        push @options, $tree[$index];
        my $o = $gbt->{options}->{$toggle}->{$tree[$index]};
        push @options, @{$o} if defined $o;
      }

      for my $move (@options) {
#print "move is $move\n";
        my ($treeid, $allow, $newscore, $cloned, @treecopy) = (undef, 1, 0, undef, @tree);
        my $moveisP = $move eq 'P';
#print "treeid is $treeid\n";
#print "treeid is ($treeid)\n";
#print "treeid is ($treeid), move is $move\n";
#print "treeid is ($treeid), move is $move\n" if defined $treeid;
#print "treeid is ($treeid), move is $move\n" if defined $treeid && defined $move;
#comment about trouble removing comments
#haha#
#if (defined $treeid && defined $moveprint) { "treeid is ($treeid), move is $move\n"; }
#if (defined $treeid && defined $move) { print "treeid is ($treeid), move is $move\n"; }
#print "treeid is ($treeid), move is $move\n";
        if ($moveisP) {
          $treeid = $lastid;
#print "***** are we here?\n\n";
        } else {
#          my $tid = "$toggle$move";
#print "($move)\n";
#          ($treecopy[$index], $newscore, undef, $cloned) = exists $gbt->{plays}->{$tid} ? @{$gbt->{plays}->{$tid}} : _play($gbt, $toggle, $move, $tid);
#          ($treecopy[$index], $newscore, undef, $cloned) = _play($gbt, $toggle, $move, $tid);
          ($treecopy[$index], $newscore, undef, $cloned) = _play($gbt, $toggle, $move);
          splice @treecopy, $index, 1 unless $treecopy[$index];
          if (@treecopy) {
            $treeid = join '', @treecopy;
#print Dumper $gbt->{history};
            if (exists $gbt->{history}->{$treeid}) {
#print "exists $treeid\n";
              $allow = !$doneP && ($gbt->{passflag} || forcedpass($gbt, $index, $toggle, @tree));
              ($moveisP, $newscore, $move, @treecopy) = (1, 0, 'P', @tree) if $allow;
            }
          }
        }
        if ($allow) {
          $newscore += $lastscore + ($gbt->{lmbflag} ? $toggle : 0);
#          if ($treeid) {
          if (defined $treeid) {
            $doneP = $moveisP;
#            $gbt->{history}->{$treeid} = 1 unless $moveisP;
#            $gbt->{history}->{$treeid} = 1; ## unless $moveisP; # who knows
            $gbt->{history}->{$treeid} = 1 unless $moveisP; # .
#print "treeid is $treeid\n";
#            onemove($gbt, $treeid, -$toggle, "$path:$move", $moveisP, $newscore - ($gbt->{passtaxflag} && $moveisP ? $toggle : 0), @treecopy);
#            if (!exists $gbt->{leaves}->{"$path:$move"}) { # also this works (looks slower)
            unless ($lastmoveP && $moveisP) { # some small test language (careful now with .)
              onemove($gbt, $treeid, -$toggle, "$path:$move", $moveisP, $newscore - ($gbt->{passtaxflag} && $moveisP ? $toggle : 0), @treecopy);
            }
            unless ($moveisP) {
              delete $gbt->{history}->{$treeid};
#              extractcloned($gbt, $cloned) if defined $cloned;
            }

          } else {
            $gbt->{leaves}->{"$path:$move:P:P"} = $newscore;
          }
          extractcloned($gbt, $cloned) if defined $cloned;
        }
# extractcloned($gbt, $cloned) if defined $cloned;
      }

    }

  }
# extractcloned($gbt, $gbtclone) if defined $gbtclone;           
}
=cut

sub forcedpass {
  my ($gbt, $index, $toggle, @tree) = @_;
  my $result = 1;

OUTER: for my $i (0..$#tree) {
    if ($tree[$i] && $i != $index) {
      my @copy = @tree;
      my @options = ($copy[$i]);
      if (exists $gbt->{options}->{$toggle} && exists $gbt->{options}->{$toggle}->{$copy[$i]}) {
        my $o = $gbt->{options}->{$toggle}->{$copy[$i]};
        push @options, @{$o};# if defined $o;
      }

      for (@options) {
#        ($copy[$i]) = fpplay($gbt, $toggle, $_);
        $copy[$i] = fpplay($gbt, $toggle, $_);
        if (!exists $gbt->{history}->{join ':', sort @copy}) {
#print "can get to ", join('', @copy), "\n";
#print Dumper @copy;
          $result = 0;
          last OUTER;
        }
      }

    }
  }

#print "forced pass $result\n";
  return $result;
}

sub fpplay {
  my ($gbt, $toggle, $id) = @_;
#  my $rightorleft = $gbt->{pairs}->{$id}->[$toggle < 0];
  if (exists $gbt->{pairs}->{$id}->[$toggle < 0]) {
#print "in fpplay\n";
#print Dumper $gbt->{pairs}->{$rightorleft};
		return $gbt->{pairs}->{$id}->[$toggle < 0];
#    return $gbt->{pairs}->{$rightorleft}
  }
  return '';
}

=lastforcedpass
sub forcedpass {
  my ($gbt, $index, $toggle, @tree) = @_;

  for my $i (0..$#tree) {
    if ($tree[$i] && $i != $index) {
      my @copy = @tree;
      my @options = ($copy[$i]);
      my $o = $gbt->{options}->{$toggle}->{$copy[$i]};
      push @options, @{$o} if defined $o;

      for (@options) {
        ($copy[$i]) = _play($gbt, $toggle, $_);
        return 0 if !exists $gbt->{history}->{join '', @copy};
      }

    }
  }

  return 1;
}
=cut

sub allpp {
  my ($pp, @tree) = @_;
  my $allduffers = 1;

  for (@tree) {
#print "abandon pp $_\n" if !exists $pp->{$_} && !exists $kos->{$_};   
#    return 0 if !exists $pp->{$_};# && !exists $kos->{$_};
    if (!exists $pp->{$_}) { #;# && !exists $kos->{$_};
      $allduffers = 0;
      last;
    }
  }

  return $allduffers;
#  return 1;
}

sub alltwigless {
  my ($gbt, @tree) = @_;

  for (@tree) {
    return 0 if !exists $gbt->{twigless}->{$_} 
                || (exists $gbt->{options}->{1} && exists $gbt->{options}->{1}->{$_})
                || (exists $gbt->{options}->{-1} && exists $gbt->{options}->{-1}->{$_})
                || defined $gbt->{pairs}->{$_}->[4];
  }

  return 1;
#  return 0;
}

sub _play {
  my ($gbt, $toggle, $id, $fptflag, $sflag) = @_; # findpoortreesflag, strategyflag
  my @result = ('', 0, 0);
  my $pairid = $gbt->{pairs}->{$id};
  my $rightorleft = $pairid->[$toggle < 0];
  if (exists $gbt->{pairs}->{$rightorleft}) {
    my $rightorleft = $gbt->{pairs}->{$id}->[$toggle < 0];
    $result[0] = $rightorleft;
    if (($gbt->{loopflag} || $fptflag) && exists $gbt->{kos}->{$id, $rightorleft}) {
#      $result[1] = $toggle;
      $result[1] = $sflag ? 1 : $toggle;
      $result[2] = 1;
    }
  } else {
    $result[1] = $sflag ? $rightorleft : $toggle * $rightorleft;
#print "$id $result[1]\n";
  }
  if (!defined $fptflag) {
#    $gbt->{plays}->{$tid}->[3] = applytrigger($gbt, $pairid->[4]) if defined $pairid->[4];
    $result[3] = applytrigger($gbt, $pairid->[4]) if ref $pairid->[4] eq 'HASH';
#    $result[3] = applytrigger($gbt, $pairid->[4]) if defined $pairid->[4];
#    $gbt->{plays}->{$tid} = \@result;
  }
  return @result;
}

=tidgone
sub _playwithtid {
  my ($gbt, $toggle, $id, $tid) = @_;
  my @result = ('', 0, 0);
  my $pairid = $gbt->{pairs}->{$id};
  my $rightorleft = $pairid->[$toggle < 0];
  if (exists $gbt->{pairs}->{$rightorleft}) {
    $result[0] = $rightorleft;
    if (($gbt->{loopflag} || !defined $tid) && exists $gbt->{kos}->{$id, $rightorleft}) {
      $result[1] = $toggle;
      $result[2] = 1;
    }
  } else {
    $result[1] = $toggle * $rightorleft;
  }
  if (defined $tid) {
#    $gbt->{plays}->{$tid}->[3] = applytrigger($gbt, $pairid->[4]) if defined $pairid->[4];
    $result[3] = applytrigger($gbt, $pairid->[4]) if defined $pairid->[4];

# this could somehow go into bestpaths later

    if (!defined $pairid->[2 + ($toggle < 0)]) {
#      my $plural = $result[1] == $toggle ? '' : 's';
      my $plural = $result[1] == $toggle ? '' : message(22);
#      $pairid->[2 + ($toggle < 0)] = join ' ', $toggle > 0 ? 'left' : 'right', "plays $id", $result[0] ? "to $result[0]" : "($result[1] point$plural)";
      my $leftorright = $toggle > 0 ? message(56) : message(55);
#      my $idornumber = $result[0] ? "to $result[0]" : "($result[1] point$plural)";
      my $idornumber = $result[0] ? message(52, $result[0]) : message(53, $result[1], $plural);
#      $pairid->[2 + ($toggle < 0)] = "$leftorright plays $id $idornumber";
      $pairid->[2 + ($toggle < 0)] = message(54, $leftorright, $id, $idornumber);

# end of this could later

    }
    $gbt->{plays}->{$tid} = \@result;
  }
  return @result;
}
=cut

sub applytrigger { # options?
  my ($gbt, $triggerhash) = @_;
#  my %pairs = %{$gbt->{pairs}};
#  my %twigless = %{$gbt->{twigless}};
#  my %pp = %{$gbt->{pp}};
#  my %kos = %{$gbt->{kos}};
#  my $cloned = {pairs => \%pairs, twigless => \%twigless, pp => \%pp, kos => \%kos};
  my $cloned = clone($gbt);
  $Carp::CarpLevel = 2; # this helps somehow with multilevel carps

#  while (my ($k, $v) = each %$triggerhash) { # Data::Dumper bug ?
  for my $k (keys %$triggerhash) {
#    if (!$gbt->{warningsoffflag} && !exists $gbt->{pairs}->{$k}) {
#      $Carp::CarpLevel = 1;
#      carp message(63, $k);
#    }
#    my ($errortype, $errormessage) = $gbt->_pair($k, @$v, 1); # 1 for ispook # oh
#    my ($errortype, $errormessage) = $gbt->_pookpair($k, \@$v, 1);
#    my ($errortype, $errormessage) = $gbt->_pookpair($k, \@$v);
#    my ($errortype, $errormessage) = $gbt->_pookpair($k, $v);
    my ($errortype, $errormessage) = $gbt->_pookpair($k, $triggerhash->{$k});
#print "id is $k\n";
#print "$errortype\n";
#    if ($errortype == 1) {
#      $Carp::CarpLevel = 2;
#      croak $errormessage;
#    }
    if ($errortype == 2) {
      $Carp::CarpLevel = 1;
      carp $errormessage;
    }
#print "$errortype\n";
#print "$k=>\n";
#print Dumper @$v;
#print Dumper @$v; # somewhere around here - see pookcheck
#  $Carp::CarpLevel = 2;
  }
#  $Carp::CarpLevel = 2;
#  checkpairs($gbt);
  $Carp::CarpLevel = 0;
  $gbt->{kos} = findkos($gbt);
  $gbt->{pp} = findpoortrees($gbt);
#  $gbt->{plays} = {}; # not very efficient
  return $cloned;
}

sub clone {
  my ($gbt) = @_;
  my %pairs = %{$gbt->{pairs}};
  my %twigless = %{$gbt->{twigless}};
  my %pp = %{$gbt->{pp}};
  my %kos = %{$gbt->{kos}};
#  my %history = %{$gbt->{history}};
  return {pairs => \%pairs, twigless => \%twigless, pp => \%pp, kos => \%kos}; # hmm too many forced passes # (!) see pookcheck hoho
#  return {pairs => \%pairs, twigless => \%twigless, pp => \%pp, kos => \%kos, history => \%history};
}

sub extractcloned {
  my ($gbt, $cloned) = @_;
#  my %thiscloned = %{$cloned};

#  for (qw(pairs twigless pp kos history)) {
  for (qw(pairs twigless pp kos)) {
    $gbt->{$_} = $cloned->{$_};
  }
#print Dumper $gbt->{pairs}->{c};
}

1;
