package Games::BinaryishTrees::viewer;

use strict;
use warnings;
use Games::BinaryishTrees::messages qw(message rightorleftmessage);
use Games::BinaryishTrees::utils qw(indexof);

require Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = qw(view viewpair viewpairtiny);

sub view {
  my ($self, $options) = @_;
#  my ($self, @options) = @_;
  my $view = '';
#  if (ref $options eq 'HASH') {
  if (ref $options eq 'ARRAY') {
    $options = {pairs => $options->[0], options => $options->[1], pooks => $options->[2], solve => $options->[3]}; 
#  my $options = {pairs => $options[0], options => $options[1], pooks => $options[2], solve => $options[3]}; 
  } else {
    $options = {pairs => 1, options => 1, pooks => 1, solve => 1};
  }
  $view .= viewpairs($self) if $options->{pairs};
  $view .= viewoptions($self) if $options->{options}; # x 3 hoho
  $view .= viewpooks($self) if $options->{pooks};
  $view .= viewsolve($self) if $options->{solve};
  return $view;
}

sub viewpairs {
  my $self = shift;
  my $view = '';

  for my $k (sort keys %{$self->{pairs}}) {
    $view .= viewpairtiny($self, $k);
 #   $view .= message(70, $k, $self->{pairs}->{$k}->[0], $self->{pairs}->{$k}->[1]);
#    $view .= viewpair($self, $k);
  }

  return $view;
}

sub viewpairtiny {
  my ($self, $k) = @_;
  return message(70, $k, $self->{pairs}->{$k}->[0], $self->{pairs}->{$k}->[1]);
}

sub viewpair {
  my ($self, $k) = @_;
  my $view = '';
  if (exists $self->{pairs}->{$k}) {
#    $view = message(70, $k, $self->{pairs}->{$k}->[0], $self->{pairs}->{$k}->[1]);
    $view = viewpairtiny($self, $k);
    if (ref $self->{pairs}->{$k}->[4] eq 'HASH') {
      $view = pooklook($view, $self->{pairs}->{$k}->[4], $k, 1);
    }
    my $translate = rightorleftmessage();

    for my $lr (sort keys %{$self->{options}}) {
#    for my $lr (1, -1) {
      if (exists $self->{options}->{$lr}->{$k}) {
#        $view .= message(71, $translate->{$lr}, join(' ', $k, @{$self->{options}->{$lr}->{$k}}));
        $view .= message(71, $translate->{$lr}, $k, join(' ', @{$self->{options}->{$lr}->{$k}}));
      }
    }

    for my $lr (sort keys %{$self->{options}}) {
#    for my $lr (1, -1) {
      if (exists $self->{options}->{$lr}->{$k}) {
        my $o = $self->{options}->{$lr};

        for my $optionkey (sort keys %{$o}) {
  #        $view .= message(71, $translate->{$lr}, join(' ', $optionkey, @{$o->{$optionkey}})) if defined indexof($k, @{$o->{$optionkey}});
          $view .= message(76, $k, $translate->{$lr}, $optionkey) if defined indexof($k, @{$o->{$optionkey}});

        }

      }
    }

  }
  return $view;
}

sub viewoptions {
  my $self = shift;
  my $view = '';
#  my $translate = {1 => message(50), -1 => message(49)};
  my $translate = rightorleftmessage();

  for my $lr (sort keys %{$self->{options}}) {
#  for my $lr (1, -1) {# so they appear
    for my $k (sort keys %{$self->{options}->{$lr}}) {
#      $view .= message(71, $k, $translate->{$lr}, join(' ', @{$self->{options}->{$lr}->{$k}})); # obscure
#      $view .= message(71, $k, $translate->{$lr}, join(' ', $k, @{$self->{options}->{$lr}->{$k}})); # tribulatory
      $view .= message(71, $translate->{$lr}, $k, join(' ', @{$self->{options}->{$lr}->{$k}}));
    }
  }

  return $view;
}

sub viewpooks {
  my $self = shift;
  my $view = '';

  for my $k (sort keys %{$self->{pairs}}) {
    if (ref $self->{pairs}->{$k}->[4] eq 'HASH') {
      $view = pooklook($view, $self->{pairs}->{$k}->[4], $k, 1);
    }
  }

  return $view;
}

sub viewsolve {
  my $self = shift;
  my $view = '';
  $view = message(74, join(' ', @{$self->{trees}})) if @{$self->{trees}};
  return $view;
}

sub pooklook {
  my ($view, $hashish, $k, $spaces) = @_;

  for my $p (sort keys %{$hashish}) {
    $view .= message(72, $k, $p, $hashish->{$p}->[0], $hashish->{$p}->[1]);
    if (ref $hashish->{$p}->[4] eq 'HASH') {
      $view = pooklook(message(73, $view, message(75) x $spaces, $k), $hashish->{$p}->[4], $p, ++$spaces);
    }
  }

  return $view;
}

1;
