package Trees::chooser;

use strict;
use warnings;

use Trees::Loopoptions;
use Trees::Loop;
use Trees::Simple;
use Trees::Pook;
use Trees::Steps;
use Trees::StepsTwo;
use Trees::Options;
use Trees::Complex;

sub load {
  my ($gbt, $game) = @_;
  my $solution;
  if ($game eq 'loopoptions') {
    Trees::Loopoptions::pairs($gbt);
    $solution = $gbt->solve(Trees::Loopoptions::pairlist());
  } elsif ($game eq 'loop') {
    Trees::Loop::pairs($gbt);
    $solution = $gbt->solve(Trees::Loop::pairlist());
  } elsif ($game eq 'simple') {
    Trees::Simple::pairs($gbt);
    $solution = $gbt->solve(Trees::Simple::pairlist());
  } elsif ($game eq 'pook') {
    Trees::Pook::pairs($gbt);
    $solution = $gbt->solve(Trees::Pook::pairlist());
  } elsif ($game eq 'steps') {
    Trees::Steps::pairs($gbt);
    $solution = $gbt->solve(Trees::Steps::pairlist());
  } elsif ($game eq 'stepstwo') {
    Trees::StepsTwo::pairs($gbt);
    $solution = $gbt->solve(Trees::StepsTwo::pairlist());
  } elsif ($game eq 'options') {
    Trees::Options::pairs($gbt);
    $solution = $gbt->solve(Trees::Options::pairlist());
  } elsif ($game eq 'complex') {
    Trees::Complex::pairs($gbt);
    $solution = $gbt->solve(Trees::Complex::pairlist());
  }
  return $solution;
}

1;
