use strict; 
use warnings;
use lib '../lib';
use Games::BinaryishTrees;

my $gbt = new Games::BinaryishTrees;
$gbt->setwarningsoff(1);
$gbt->setsweet(1);

for my $right (0..8) {
  my $lastcount = 1;
  print "right $right\n\n";

  for my $limit (0..8) {
    my $pairlist = [];

    for (0..$limit) {
      $gbt->pair("a$_", $_, $right);
      $pairlist->[$_] = "a$_";
    }

    my $solution = $gbt->solve($pairlist);
    my $count = scalar $solution->bestpaths();
    print $count, ' (x', $count/$lastcount, ")\n";
    $lastcount = $count;
  }
  print "\n";
}

