use strict;
use warnings;
use lib qw(../lib .);
use Games::BinaryishTrees;
use Trees::chooser;

my $game = shift;
my @games = Games::BinaryishTrees::filer::readfolder('./Trees');

if (Games::BinaryishTrees::utils::inarray(\@games, $game)) {
  my $gbt = new Games::BinaryishTrees;
  $gbt->setsweet(0);
  $gbt->setstart(0);
  $gbt->setpass(1);
  $gbt->setpassplus(0);
  $gbt->setprocess(0);
  $gbt->setwarningsoff(1);
  my $solution = Trees::chooser::load($gbt, $game);
  my $type = ref $solution;
  if ($type eq 'Games::BinaryishTrees::Game') {
    print $gbt->view;
    print join("\n", $solution->bestpaths), "\n";
    print $solution->bestvalue, "\n"; # this is a comment
    $solution->computermove(0);
#    $solution->playgame(0, 1, 1, 1, 1, 1, 0, 1);
  } else {
    print "game $game found a '$type' looking for a 'Games::BinaryishTrees::Game'\n";
  }
} else {
  print "usage : peek.pl [", join(' ', @games), "]\n";
}

