use strict;
use warnings;
use lib '../lib';
use Games::BinaryishTrees;

my ($game, $pathtotrees, $jsonpackage, $jsondecodefunction, $jsonencodefunction) = @ARGV;
$pathtotrees ||= './TreesJSON';
$jsonpackage ||= 'JSON::MaybeXS';
$jsondecodefunction ||= 'decode';
$jsonencodefunction ||= 'encode';
if (-d $pathtotrees && -e "$pathtotrees/simple.json") {
  my @games = Games::BinaryishTrees::filer::readfolder($pathtotrees);
  if (Games::BinaryishTrees::utils::inarray(\@games, $game)) {
    my $gbt = new Games::BinaryishTrees;
    $gbt->setwarningsoff(1);
		eval "require $jsonpackage";
		if ($@) {
			print "a JSON module required, eg JSON::MaybeXS\n";
		} else {
			my $jsonobject = $jsonpackage->new(pretty => 1, canonical => 1);
			my $encoded = $jsonobject->$jsondecodefunction($gbt->readfile("$pathtotrees/$game"));
			$gbt->fromjson($encoded);
		  $gbt->setstart(0);
		  $gbt->setpass(1);
		  $gbt->setpassplus(0);
		  $gbt->setprocess(0);
		  $gbt->setlmb(0);
		  $gbt->setloop(0);
#      $gbt->setsweet(1);
		  $gbt->setstrategy(0);
		  print $gbt->view;
		  my $solution = $gbt->solve();
#      $solution->verbose(1);
#		  print join("\n", $solution->bestpaths), "\n";
#		  print $solution->bestvalue, "\n"; 
		  $solution->computermove(1);
  		my $json = $jsonobject->$jsondecodefunction($solution->jsonsolute($jsonpackage, $jsonencodefunction));
		  print join("\n", @{$json->{bestpaths}}), "\n";
			print $json->{bestvalue}, "\n";
#      $solution->playgame(0, 1, 1, 1, 1, 1, 0, 1);
		}
	} else {
	  print "usage : peekJSON.pl [", join(' ', @games), "] path/to/TreesJSON\n";
	}
} else {
	print "useage : peekJSON.pl game path/to/TreesJSON\n";
}

