# run from this folder (./t),
# checks some ../patterns files working

use strict;
use warnings;

use Test::More tests => 21; # looks ok until run by "make test" as check.t # subtests # ah print ok() issue 
#use Carp;
chdir '../patterns';
#chdir './checks';
my $peekanswers = peekanswers();

my $answers = {simple => 0, steps => 1, stepstwo => 1, loop => 0, loopoptions => 0, options => 1, pook => 0};

#  subtest 'subtest 3', sub {

SKIP: {
  eval { require JSON::MaybeXS };
  skip "missing JSON::MaybeXS", 7 if $@;

  for my $key (keys %$answers) {
    my $output = `perl symmetryJSON.pl $key.json`;
    checkthem($output, $answers->{$key} ? "equal\n" : "differing\n", "symmetryJSON.pl $key.json");
  }

}

#    done_testing();
#  };

#  subtest 'subtest 4', sub {

for my $key (keys %$answers) {
  my $output = `perl symmetry.pl $key`;
  my $value = $answers->{$key} ? "equal\n" : "differing\n";
  checkthem($output, $value, "symmetry.pl $key");
}
#    done_testing();
#  };

#  subtest 'subtest 5', sub {

for my $key (keys %$answers) {
  my $output = `perl peek.pl $key`;
  checkthem($output, $peekanswers->{$key}, "peek.pl $key");
#  checkthem($output, peekanswers($key), "peek.pl $key");
#  my $result = checkthem($output, peekanswers($key), "peek.pl $key");
#  print "$output, $key\n" if $result eq "oh\n";
}

#    done_testing();
#  };

sub checkthem {
  my ($output, $message, $check) = @_;
#  ok($output eq $message, $check);
#  if ($output eq $message) {
#    return "ok\n";
#  } else {
#    croak "found\n$output\nlooking for\n$message\n"; 
##    return "oh\n";
#  }
  BAIL_OUT("$check\nfound\n$output\nlooking for\n$message\n") unless ok($output eq $message, $check);
}

sub setupcheckone {
  my ($check, @params) = @_;
  my $output = `perl $check.pl @params`;
  checkthem($output, $peekanswers->{$check}, "$check.pl");
}

sub peekanswers {
#  my $key = shift;
  my $simple = <<'simple';
a is (1, 0)
b is (0, 1)
c is (10, 0)
solve a b c
c:P:P
c:P:a:b:P:P
c:P:b:a:P:P
c:a:b:P:P
c:b:a:P:P
10
simple
  my $steps = <<'steps';
a is (5, 0)
b is (4, 0)
c is (3, 0)
d is (2, 0)
e is (1, 0)
f is (0, 0)
solve a b c d e f
a:b:c:d:e:P:P
a:b:c:d:e:P:f:P:P
a:b:c:d:e:f:P:P
9
steps
  my $stepstwo = <<'stepstwo';
a123 is (5, 0)
b1 is (4, 0)
c12 is (3, 0)
c123 is (2, 0)
d2 is (1, 0)
d3 is (0, 0)
solve a123 b1 c12 c123 d2 d3
a123:b1:c12:c123:d2:P:P
a123:b1:c12:c123:d2:P:d3:P:P
a123:b1:c12:c123:d2:d3:P:P
9
stepstwo
  my $loopoptions = <<'loopoptions';
a is (4, b)
b is (a, 3)
c is (0, 1)
d is (e, 0)
e is (10, 0)
f is (a, b)
k is (5, 0)
k1 is (4, 0)
x is (d, 1000)
right options of f are x
left options of a are k k1
left options of f are x
solve f c
x:c:P:P
x:c:P:d:P:P
x:c:d:e:P:P
-1
loopoptions
  my $loop = <<'loop';
a is (4, b)
b is (a, 3)
c is (0, 1)
d is (e, 0)
e is (10, 0)
f is (a, b)
solve f c d
f:a:d:e:b:P:a:c:P:P
f:a:d:e:b:c:a:P:P
f:c:a:P:P
f:c:a:P:d:e:P:P
f:c:a:d:P:P
f:c:d:e:a:P:P
f:d:a:c:P:P
3
loop
  my $options = <<'options';
b is (4, 0)
c is (3, 0)
d is (2, 0)
right options of b are d
left options of c are b
solve b c
b:b:P:P
b:c:P:P
b:d:P:P
4
options
  my $pook = <<'pook';
a is (3, 0)
b is (1, 0)
c is (10, 0)
a pooks c to (2, 0)
solve a b c
c:a:b:P:P
11
pook
  my $simplejson = <<'simplejson';
a:b:d:P:P
a:c:b:P:P
b:a:d:P:P
b:c:a:P:P
d:a:b:P:P
d:b:a:P:P
simplejson
  my $jsonread = <<'jsonread';
b:b:P:P
b:c:P:P
b:d:P:P
4
c:a:b:P:P
11
a:b:c:d:e:f:P:P
9
x:c:d:e:P:P
-1
b:a:a1:c:j:k:h:m:P:P
b:a:a1:c:j:k:m:h:P:P
b:a:a1:c:k:j:i:l:P:P
b:a:a1:c:k:j:l:i:P:P
11
d:e:c:f:b:P:a:P:P
4
a123:b1:c12:c123:d2:d3:P:P
9
c:a:b:P:P
c:b:a:P:P
10
jsonread
  my $answers = {
    simple => $simple, 
    steps => $steps, 
    stepstwo => $stepstwo, 
    loop => $loop, 
    loopoptions => $loopoptions, 
    options => $options, 
    pook => $pook,
    simplejson => $simplejson,
    jsonread => $jsonread
  };
#  return $answers->{$key};
  return $answers;
}
