use strict;
use warnings;
use lib qw(../../lib);
use Games::BinaryishTrees;
use JSON::MaybeXS;

my $checking = shift;
$checking ||= 0;
my $gbt = new Games::BinaryishTrees;
$gbt->pair('a', 1, 0);
$gbt->pair('b', 0, 1);
$gbt->pair('c', 10, 0);
$gbt->pair('d', 1, 0);
$gbt->option('left', 'c', 'd');
$gbt->setsweet(1);
#my $pairset = ['a', 'b', 'c'];
$gbt->pairset(['a', 'b', 'c']);
my $json = JSON::MaybeXS->new(pretty => 1, canonical => 1);
if ($checking) { # keep away from file system for checking ok
  my $encoded = $json->encode($gbt->tojson());
  $gbt->setwarningsoff(1);
  $gbt->fromjson($json->decode($encoded));
} else {
  my $file = "check.json";
  $gbt->writefile($file, $json->encode($gbt->tojson()));
  $gbt->setwarningsoff(1);
  $gbt->fromjson($json->decode($gbt->readfile($file)));
  print "json $file written\n";
}
my $solution = $gbt->solve();
print join("\n", $solution->bestpaths), "\n";

