use strict;
use warnings;
use lib '../../lib';
use Games::BinaryishTrees;
use JSON::MaybeXS;

my ($game, $pathtotrees) = @ARGV;
$pathtotrees ||= './TreesJSON';
if (-d $pathtotrees && -e "$pathtotrees/simple.json") {
  my @games = Games::BinaryishTrees::filer::readfolder($pathtotrees);

  if (Games::BinaryishTrees::utils::inarray(\@games, $game)) {
    my $gbt = new Games::BinaryishTrees;
    $gbt->setwarningsoff(1);
    my $pairset = $gbt->fromjson(decode_json($gbt->readfile("$pathtotrees/$game")));

    for my $startsetting (0..1) {

      for my $ppsetting (0..1) {
        $gbt->setstart($startsetting);
        $gbt->setpass(1);
        $gbt->setpassplus($ppsetting);
        $gbt->setstrategy(2);
        my $solution = $gbt->solve($pairset);
        print join("\n", $solution->bestpaths), "\n";
        print $solution->bestvalue, "\n"; 
      }

    }

  } else {
    print "usage : peekJSON.pl [", join(' ', @games), "] path/to/Trees\n\nCompares all best paths with their reverse when passed first\n";
  }
} else {
  print "useage : peekJSON.pl game path/to/TreesJSON\n";
}

