use strict;
use warnings;
use lib qw(../../lib);
use Games::BinaryishTrees;
use Games::BinaryishTrees::Trees::chooser;

my $game = shift;
my @games = Games::BinaryishTrees::filer::readfolder('../../lib/Games/BinaryishTrees/Trees');

if (Games::BinaryishTrees::utils::inarray(\@games, $game)) {
  my @leftstartspaths;
  my @rightstartspaths;

  for my $setting (0..1) {
    my $gbt = new Games::BinaryishTrees;
    $gbt->setsweet(1);
    $gbt->setstart($setting);
    $gbt->setwarningsoff(1);
    my $solution = Games::BinaryishTrees::Trees::chooser::load($gbt, $game); # redefined message absent ... # came along see above
    if ($setting) {
      @rightstartspaths = $solution->bestpaths();
#      @leftstartspaths = $solution->bestpaths();
    } else {
      @leftstartspaths = $solution->bestpaths();
#      @rightstartspaths = $solution->bestpaths();
    }
  }

  print compare(\@leftstartspaths, \@rightstartspaths), "\n";

} else {
  print "usage : symmetry.pl [", join(' ', @games), "]\n\nCompares all best paths with their reverse when passed first\n";
}

sub compare {
  my ($aref, $bref) = @_;
  my %ahash = map { join(':', grep { $_ ne 'P' } split ':') => 1 } @$aref;
  my %bhash = map { join(':', grep { $_ ne 'P' } split ':') => 1 } @$bref;
#  my %bhash = map { join(':', grep { $_ !~ /P/ } split ':') => 1 } @$bref;
#  my %bhash = map { s/:P:P$//r => 1 } @$bref; # also possible, (see perlver)
  my %breversed;

  for my $bkey (keys %bhash) {
    my $reverse = join ':', reverse split ':', $bkey;
    $breversed{$reverse} = $bhash{$bkey};
  }
#  print join("\n", sort keys %ahash), "\n\n";
#  print join("\n", sort keys %bhash), "\n\n";
  return comparehashes(\%ahash, \%breversed);
}

sub comparehashes {
  my ($ahashref, $bhashref) = @_;
  if (keys %{$ahashref} == keys %{$bhashref}) {

    for my $akey (keys %{$ahashref}) {
      if (exists $bhashref->{$akey} && $ahashref->{$akey} eq $bhashref->{$akey}) {
      } else {
        return 'differing';
      }
    }

  } else {
    return 'differing';
  }
  return 'equal';
}

