use strict; 
use warnings;
use lib './lib';
use Test::More tests => 1242; # not so easy to see big picture
use Test::Exception;
#use Test::Carp;
use Carp;
#use Data::Printer;
#use Data::Dumper;
#use Storable;
#use Trees::Loopoptions;
#use Trees::Loop;
#use Trees::Simple;
#use Trees::Pook;
#use Trees::Steps;

BEGIN {
  use_ok('Games::BinaryishTrees'); 
  use_ok('Games::BinaryishTrees::Trees::Simple');
  use_ok('Games::BinaryishTrees::Trees::Loop');
  use_ok('Games::BinaryishTrees::Trees::Loopoptions');
  use_ok('Games::BinaryishTrees::Trees::Pook');
  use_ok('Games::BinaryishTrees::Trees::Steps');
}

my ($testtorun, $lesstests, $bailout) = @ARGV;
#check();
checkthem();

sub checkthem {
#  my ($testtorun, $lesstests, $bailout) = @ARGV;
#  $testtorun ||= 2;
  if (!defined $testtorun) {
    $testtorun = 3;
  }
  $bailout ||= 0; # is badgoodidea
  my $answersfolder = './t/answers';
#  my $gbt = new Games::BinaryishTrees;
#  ok(defined($gbt) && ref $gbt eq 'Games::BinaryishTrees', 'new test');
#  isa_ok($gbt, 'Games::BinaryishTrees', 'new check');
#  my $gbt = new_ok('Games::BinaryishTrees');
  my $gbt = Games::BinaryishTrees->new;
  isa_ok($gbt, 'Games::BinaryishTrees');
#  my $paramnum = $gbt->{parameters};
  ok($gbt->setparams == 9, 'setparams test');
  my $paramnum = scalar $gbt->setparams;
#  my $paramnum = 9;
  $lesstests ||= 2**($paramnum-1) - 1; # (-1) as not checking strategyvalue
  throws_ok {$gbt->setparams(1, 2, 3, 4, 5, 6, 7, 8, 9, 10)} qr/When passing parameters, $paramnum or less are needed/, 'wrong parameter number test more';
#  throws_ok {$gbt->setparams(1)} qr/When passing parameters, $paramnum are needed/, 'wrong parameter number test less';
  testsetparams($gbt, 0, 2**($paramnum-1) - 1, $paramnum -1 ); # as above (stategyvalue)
  testparams($gbt);
  testpairs($gbt);
  testhistory($gbt);
  #testlanguage($gbt);
  my ($start, $end);
#  if ($testtorun == 2) {
  if ($testtorun == 3) {
    $start = 0;
    $end = 2;
  } else {
    $start = $end = $testtorun;
  }

  my @failures;

  for my $check ($start..$end) {
#    my ($testname, $tree, $file) = parseargv($gbt, $check);
    my ($testname, $tree) = parseargv($gbt, $check);
    my $goodanswers = readgoodanswers("$answersfolder/$testname.txt", $paramnum - 1);
#p $goodanswers;
#    my $goodanswers = readgoodanswers($file, $paramnum);
#    push @failures, testtree($gbt, $tree, 0, 2**($paramnum - $lesstests) - 1, $goodanswers, $testname, $paramnum);
    check("set pairset $check", $tree, $gbt->pairset($tree));
#    check("setparams check $check", '0 0 0 0 0 0 0 0 undef', $gbt->setparams(0, 0, 0, 0, 0, 0, 0, 0, undef));
    push @failures, testtree($gbt, $tree, 0, $lesstests, $goodanswers, $testname, $paramnum - 1);
    #$gbt->setparams(0, 0, 0, 0, 0, 0, 0, 0); 
    check("setparams check $check", '0 0 0 0 0 0 0 0 undef', $gbt->setparams(0, 0, 0, 0, 0, 0, 0, 0, undef));
    gametests($gbt, $testname, $tree);
    misctests($gbt, $testname);
  }

  testgame($gbt, $answersfolder);
  optionchecks($gbt);
  testlanguage($gbt);
#  optionchecks($gbt);
  print join "\n", @failures, "\n" if @failures;
#  print "ko tests fudged with generated sweet answers enshrined in ko.txt\n";
  print "loop tests fudged with generated sweet answers enshrined in loop.txt\n";
#  print "passplusflag logic changed, 24 missing answer results + 32 for setsweet\n";
}

sub parseargv {
  my $gbt = shift;
  $gbt->deletepair();
#print "parseargv $_[0]\n";
  if ($_[0] == 1) {
#    ko($gbt);
    Games::BinaryishTrees::Trees::Loop::pairs($gbt);
#    return 'ko', Trees::Loop::pairlist(), 'ko.txt';
#    return 'loop', Trees::Loop::pairlist(), 'loop.txt';
    return 'loop', Games::BinaryishTrees::Trees::Loop::pairlist();
#    return 'ko', ['f', 'c', 'd'], 'ko.txt';
  } elsif ($_[0] == 2) {
#    pook($gbt);
    Games::BinaryishTrees::Trees::Pook::pairs($gbt);
    return 'pook', Games::BinaryishTrees::Trees::Pook::pairlist();
#    return 'pook', Trees::Pook::pairlist(), 'pook.txt';
  } else {
#    simple($gbt);
    Games::BinaryishTrees::Trees::Simple::pairs($gbt);
    return 'simple', Games::BinaryishTrees::Trees::Simple::pairlist();
#    return 'simple', Trees::Simple::pairlist(), 'simple.txt';
  }
}

sub readgoodanswers {
  my ($filepath, $paramnum) = @_;
  open(my $info, '<', $filepath) || croak "Could not open $filepath: $!";
#  my $info = readfile($file);
  my ($goodanswers, $params, @answer);
  my $total = 0;

  while (my $line = <$info>) {
    chomp $line;
    $line =~ s/\s//g;
    if ($line =~ /^[01]{$paramnum}$/ or eof($info)) {
      $total++;
#print "$total $line\n";
      if (@answer) {
#        my %copy = map { $_ => 1 } @answer;
#        ok(!exists $goodanswers->{$params}, "duplicate $params");
        if (exists $goodanswers->{$params}) {
          croak "duplicate $params\n";
        }
        my %copy = map { $_ => 1 } @answer;
        $goodanswers->{$params} = \%copy;
        @answer = ();
      }
      $params = $line;  
    } else {
      my $paramnumoneless = $paramnum - 1;
      if ($line =~ /^[01]{$paramnumoneless}$/) {
        croak "slightly too few parameters at $line\n";
      } else {
        push @answer, $line;
      }
    }
  }

#  cmp_ok($total, '==' , 1 + 2**$paramnum, "o-oh $total");
  if ($total != 1 + 2**$paramnum) { # one for end of file
    croak "o-oh $total\n";
  }
#  close $filepath;
  close $info;
  return $goodanswers;
}

sub testparams {
  my ($gbt) = @_;

  for my $subname (qw(setstart setpass setpassplus setlmb setloop setpasstax setprocess setsweet)) {
#  for my $subname (qw(setstart setpass setpassplus setlmb setloop setpasstax setprocess)) {
    for (1, 0) {
#      ok($_ == $gbt->$subname($_ == 1), "param set test $subname $_");
      ok($_ == $gbt->$subname($_), "param set test $subname $_");
      ok($_ == $gbt->$subname(), "param set view $subname $_");
      ok($_ == $gbt->$subname(), "param set view not changed $subname $_");
    }
  }

}

sub testsetparams {
  my ($gbt, $teststart, $testend, $paramnum) = @_;

  for ($teststart..$testend) {
    my $params = dec2bin($paramnum, $_);
    my @params = split '', $params;
#    my @paramsback = $gbt->setparams(@params);
    check("param test $params", join(' ', @params, 'undef'), $gbt->setparams(@params));
#    is_deeply(\@params, \@paramsback, "param test $params");
  }

}

sub testpairs {
  my ($gbt) = @_;
  throwtest($gbt, \&Games::BinaryishTrees::pair, 'id incorrect format test1', qr/id '1' not allowed/, '1', 1, 2);
  throwtest($gbt, \&Games::BinaryishTrees::pair, 'id incorrect format test2', qr/id 'P:i' not allowed/, 'P:i', 1, 2);
#  throwtest($gbt, \&Games::BinaryishTrees::pair, 'id incorrect format test3', qr/id 'P' not allowed/, 'P', 1, 2);
#  throwtest($gbt, \&Games::BinaryishTrees::pair, 'id incorrect format test4', qr/id 'quit' not allowed/, 'quit', 1, 2);
  throwtest($gbt, \&Games::BinaryishTrees::pair, 'id incorrect format test3', qr/P is a reserved word/, 'P', 1, 2);
  throwtest($gbt, \&Games::BinaryishTrees::pair, 'id incorrect format test4', qr/quit is a reserved word/, 'quit', 1, 2);
  check('%s change', '%s is reserved', $gbt->changethis(69, '%s is reserved'));
  throwtest($gbt, \&Games::BinaryishTrees::pair, 'id incorrect format test5', qr/quit is reserved/, 'quit', 1, 2);
#  my $reserved = $gbt->changethis(69, '%s is reserved'); # requires ease away %s
  my $reserved = 'quit is reserved';
  throwtest($gbt, \&Games::BinaryishTrees::pair, 'id incorrect format test6', qr/$reserved/, 'quit', 1, 2);
  BAIL_OUT("unexpected answer 1") unless is_deeply($gbt->pair('a1', 'z', 2), {a1 => ['z', 2]}, 'pair a1 z 2 check');
  throwtest($gbt, \&Games::BinaryishTrees::solve, 'id not defined test a', qr/id z not defined/, ['a1']);
  throwtest($gbt, \&Games::BinaryishTrees::deletepair, 'deletepair test', qr/pair z1 not found/, 'z1');
  check('delete pair a1 check', 1, $gbt->deletepair('a1'));
#$gbt->deletepair('a1');
#  $gbt->pair('b1', 1, 2);
  BAIL_OUT("unexpected answer 2") unless is_deeply($gbt->pair('b1', 1, 2), {b1 => [1, 2]}, 'pair b1 1 2 check');
  throwtest($gbt, \&Games::BinaryishTrees::solve, 'id not defined test b', qr/id z not defined/, ['z']);
  throwtest($gbt, \&Games::BinaryishTrees::pair, 'not integer test', qr/'2.5' not recognised/, 'a1', 1, 2.5);
  $gbt->deletepair();
}

sub testhistory {
  my $gbt = shift;
  throwtest($gbt, \&Games::BinaryishTrees::history, 'history parameters test', qr/first parameter of \"history\" needs to be an array reference/,  'b1');
  throwtest($gbt, \&Games::BinaryishTrees::deletehistory, 'deletehistory parameters test', qr/not an array reference/, 'b1');
  test('history test', 'a', $gbt->history(['a']));
  test('delete history test', '', $gbt->deletehistory(['a']));
}

sub misctests {
  my ($gbt, $string) = @_;
#  throwtest($gbt, \&Games::BinaryishTrees::diff, 'diff parameters test1', qr/need two trees to diff and no more/,  ['b1']);
#  throwtest($gbt, \&Games::BinaryishTrees::diff, 'diff parameters test2', qr/First parameter of \"diff\" needs to be an array reference/, 'b1');
  if ($string eq 'loop') {
    $string = ['f', 'c'];
    test('diff loop test', '1', $gbt->diff($string));
    test('sente loop test', '8', $gbt->sente($string));
    my $solution = $gbt->solve(['f', 'c', 'd']);
    isa_ok($solution, 'Games::BinaryishTrees::Game', 'setup game check');
#    $solution->verbose(1);
    check('verbose to 1', 1, $solution->verbose(1));
    my $goodanswers = {'left plays d to e:right plays e (0 points):left plays c (0 points):right plays f to b:left plays b to a:P:left plays a (4 points):P:P' => 1};
    testverbose($solution, $goodanswers, 'loop verbose 1');
    $solution = $gbt->solve(['f', 'c', 'd'], 0, 0, 0, 0, 1);
#    $solution->verbose(1);
    check('verbose to 1', 1, $solution->verbose(1));
    $goodanswers = {'left plays d to e:right plays e (0 points):left plays c (0 points):right plays f to b:left plays b to a:P:left plays a (4 points):P:P' => 1};
    testverbose($solution, $goodanswers, 'loop verbose 2');
    check("setparams loop reset undef missing from end", '0 0 0 0 0 0 0 0 undef', $gbt->setparams(0, 0, 0, 0, 0, 0, 0, 0));
  } elsif ($string eq 'simple') {
    throwtest($gbt, \&Games::BinaryishTrees::diff, 'diff parameters test1', qr/need two trees to diff and no more/,  ['b1']);
    throwtest($gbt, \&Games::BinaryishTrees::diff, 'diff parameters test2', qr/First parameter of \"diff\" needs to be an array reference/, 'b1');
    $string = ['a', 'c'];
    test('diff simple test', '1', $gbt->diff($string));
    test('sente diff test', '9', $gbt->sente($string));
    my $solution = $gbt->solve(['a', 'b', 'c']);
#    $solution->verbose(1);
    check('verbose to 1', 1, $solution->verbose(1));
    my $goodanswers = {'left plays c (10 points):right plays b (-1 points):left plays a (1 point):P:P' => 1,
                       'left plays c (10 points):right plays a (0 points):left plays b (0 points):P:P' => 1};
    testverbose($solution, $goodanswers, 'simple verbose 1');
#    $gbt->pair('d', 10, 0, 'bingo');
#    $gbt->pair('e', 1, 0, 'left one (e)', undef);
    is_deeply($gbt->pair('d', 10, 0, 'bingo'), {d => [10, 0, 'bingo',]}, 'bingo setup check');
    is_deeply($gbt->pair('e', 1, 0, 'left one (e)'), {e => [1, 0, 'left one (e)']}, 'left one (e) setup check');
    $solution = $gbt->solve(['e', 'b', 'd']);
    check('verbose to 1', 1, $solution->verbose(1));
    $goodanswers = {'bingo:right plays e (0 points):left plays b (0 points):P:P' => 1,
                    'bingo:right plays b (-1 points):left one (e):P:P' => 1};
    testverbose($solution, $goodanswers, 'simple verbose 2');
    $goodanswers = {'d:e:b:P:P' => 1, 'd:b:e:P:P' => 1};
#    $solution->verbose(0);
    check('verbose to 0', 0, $solution->verbose(0));
    testverbose($solution, $goodanswers, 'simple verbose 3');
  } elsif ($string eq 'pook') {
#    $gbt->pair('e', 0, 3, [undef, undef, {'c' => ['a', 0, undef, undef, {'b' => ['x', 0, undef, undef, {'d' => ['a', 0, ]}]}]}]);
#    $gbt->pair('e', 0, 3, undef, undef, {'c' => ['a', 0, undef, undef, {'b' => ['x', 0, undef, undef, {'d' => ['a', 0, ]}]}]});
    is_deeply($gbt->pair('e', 0, 3, undef, undef, {'c' => ['a', 0, undef, undef, {'b' => ['x', 0, undef, undef, {'d' => ['a', 0, ]}]}]}), {e => [0, 3, undef, undef, {'c' => ['a', 0, undef, undef, {'b' => ['x', 0, undef, undef, {'d' => ['a', 0, ]}]}]}]}, 'pook not defined setup check');
    throwtest($gbt, \&Games::BinaryishTrees::solve, 'pook left not defined test', qr/id x not defined/, ['a', 'b', 'c'], 0, 0, 0, 0, 0, 0, 0, 0, undef);
#    carptest($gbt, \&Games::BinaryishTrees::solve, 'pook redefinition warnings test', qr/id x not defined/, ['a', 'b', 'c']);
#    $gbt->pair('e', 0, 3, [undef, undef, 'b']);
#    $gbt->pair('e', 0, 3, undef, undef, {'c' => ['a', 0, undef, undef, 0]});
    is_deeply($gbt->pair('e', 0, 3, undef, undef, {'c' => ['a', 0, undef, undef, 0]}), {e => [0, 3, undef, undef, {'c' => ['a', 0, undef, undef, 0]}]}, 'pook error setup check');
#    throwtest($gbt, \&Games::BinaryishTrees::pair, 'pook error setup check', qr/pook needs a hash reference/, 'e', 0, 3, undef, undef, 'b');
    throwtest($gbt, \&Games::BinaryishTrees::solve, 'pook needs a hash reference test', qr/pook needs a hash reference/, ['a', 'b', 'c']);
    check('viewpair check pook', $gbt->viewpair('a'), "a is (3, 0)\na pooks c to (2, 0)\n");
    check('delete e check', 1, $gbt->deletepair('e')); # Steps uses e so track error to here where e out of Steps

    $gbt->setwarningsoff(1);
    $gbt->pair('a', 0, 0, undef, undef, {'b' => [1, -1]});
    $gbt->pair('b', 0, 0);

    my $solution = $gbt->solve(['a', 'b']);
    my $goodanswers = {'a:b:P:P' => 1};
    check('verbose to 0', 0, $solution->verbose(0));
    testverbose($solution, $goodanswers, 'pook verbose 1');
    check('viewpair check pook 1', "b is (0, 0)\n", $gbt->viewpair('b'));

      check('verbose to 1', 1, $solution->verbose(1));
      $goodanswers = {'left plays a (0 points):right plays b (1 point):P:P' => 1};
      testverbose($solution, $goodanswers, 'pook verbose 2');

    TODO: {
      local $TODO = "checks to fix"; # 

#      check('viewpair check pook 2', "b is (0, 0)\n", $gbt->viewpair('b'));
#      ok("b is (0, 0)\n" eq $gbt->viewpair('b'), 'viewpair check pook 2');
      ok(1 == 2, '1 == 2');
      ok(1 == 1, '1 == 1'); # both pass, this one output looks neater
    }

    ok("b is (0, 0)\n" eq $gbt->viewpair('b'), 'viewpair check pook 2a');
  }
}

sub testverbose {
  my ($solution, $goodanswers, $testname) = @_;
  my %answers = map { $_ => 1 } $solution->bestpaths();
  my $success = is_deeply(\%answers, $goodanswers, $testname) || diag(join "\n", 'missing answers', diff($goodanswers, \%answers), 'extra answers', diff(\%answers, $goodanswers));
  if (!$success) { # if success == 0
    BAIL_OUT('stop') if $bailout;
  }

}

sub optionchecks {
  my $gbt = shift;
#  checkoptions($gbt);
  Games::BinaryishTrees::Trees::Loopoptions::pairs($gbt);
  my $solution = $gbt->solve(Games::BinaryishTrees::Trees::Loopoptions::pairlist());
#  my $solution = $gbt->solve(['f', 'c']);
  checkmoveto($solution, '');
#  $solution->moveto('');
  check('allchoices', 'P c f x', $solution->allchoices());
  checkmoveto($solution, 'f:c');
#  $solution->moveto('f:c');
  check('allchoices f:c', 'P a k k1', $solution->allchoices());
  checkmoveto($solution, 'f:c:k');
#  $solution->moveto('f:c:k');
  check('allchoices f:c:k', 'P', $solution->allchoices());
  checkmoveto($solution, 'c');
#  $solution->moveto('c');
  check('allchoices c', 'P f x', $solution->allchoices());
  checkmoveto($solution, 'c:f');
 # $solution->moveto('c:f');
  check('allchoices c:f', 'P b', $solution->allchoices());
  checkmoveto($solution, 'c:f:b');
#  $solution->moveto('c:f:b');
#BAIL_OUT('ok');
#  check('allchoices c:f:b', 'P a', $solution->allchoices()); # sort treeids
  check('allchoices c:f:b', 'P', $solution->allchoices());
  checkmoveto($solution, 'c:f:b:P');
#  $solution->moveto('c:f:b:P');
  check('allchoices c:f:b:P', 'P a k k1', $solution->allchoices());
  is_deeply($gbt->listoptions(), { -1 => {f => ["x"]}, 1 => {a => ["k", "k1"], f => ["x"]} }, "listoptions check");
  check('delete option a k', 'k1', @{$gbt->deleteoption('left', 'a', 'k')});
  is(undef, $gbt->deleteoption('left', 'a', 'k1'), 'delete option a k1');
  is(undef, $gbt->deleteoption('right', 'f'), 'delete option id f right');
  is_deeply($gbt->listoptions(), { -1 => {}, 1 => {f => ["x"]} }, "listoptions 2 check");
  is(undef, $gbt->deleteoption(), 'delete options');
}

sub checkmoveto {
  my ($solution, $path) = @_;
  check("moveto $path", 1, $solution->moveto($path));
}

sub gametests {
  my ($gbt, $string, $tree) = @_;
#  $gbt->setparams(0, 0, 0, 0, 0, 0, 0, 0);
#  check('setparams gametests 0', '0 0 0 0 0 0 0 0 undef', $gbt->setparams(0, 0, 0, 0, 0, 0, 0, 0, undef));
  my $solution = $gbt->solve($tree);
  if ($string eq 'simple') {
#    my $solution = $gbt->solve($tree);
    test('moveto test 1a', '1', $solution->moveto('b'));
    test('moveto test 2a', '0', $solution->moveto('a:b:d'));
    test('weight test a', '-9', $solution->weight());
    test('moves test a', 'b', $solution->moves());
    test('bestchoices test a', 'c', $solution->bestchoices());
    test('allchoices test a', 'P a c', $solution->allchoices());
    test('legalchoices test a', 'a c', $solution->legalchoices());
#    test('trees test a', 'a  c', $solution->tree());
    test('trees test aa', 'a c', $solution->tree());
    check('setparams simple 1', '1 0 0 0 0 0 0 0 undef', $gbt->setparams(1));
    $solution = $gbt->solve($tree);
    test('moveto test 1b', '1', $solution->moveto('b'));
    test('weight test ab', '-9', $solution->weight());
    check('setparams simple undo setstart 0', '0', $gbt->setstart(0));    
  } elsif ($string eq 'loop') {
    test('moveto test 1', '1', $solution->moveto('f:c'));
    test('moveto test 2', '0', $solution->moveto('f:c:e'));
    test('weight test', '-1', $solution->weight());
    test('moves test', 'f:c', $solution->moves());
    test('bestchoices test', 'a d', $solution->bestchoices());
    test('allchoices test', 'P a d', $solution->allchoices());
    test('legalchoices test', 'a d', $solution->legalchoices());
    test('trees test', 'a d', $solution->tree());
  } elsif ($string eq 'pook') {
    check('moveto check p1', '1', $solution->moveto('a'));
    check('tree check p1', 'b c', $solution->tree());
    test('view check 1', "b is (1, 0)\nc is (2, 0)\n", $solution->viewtree($solution->tree()));
    check('moveto check p2', '1', $solution->moveto());
    check('tree check p1', 'P a b c', $solution->allchoices());
    test('view check 1', "a is (3, 0)\nb is (1, 0)\nc is (10, 0)\n", $solution->viewtree($solution->allchoices()));
  }
}

sub testlanguage {
  my $gbt = shift;
  my $suggestedchoices = $gbt->seethis(0);
#  test('language seethis 0', 'suggested choices', $gbt->seethis(0));
  test('language seethis 0', $suggestedchoices, $gbt->seethis(0)); # crackerjacks, back to simple way, thencanbefix
  test('language seethis 0', 'suggested choices', $gbt->seethis(0));
#  test('language findthis P', 'suggested choices', $gbt->findthis('P')); # tofindanswer
#  test('language findthis P', [44, 45, 48, 51], $gbt->findthis('P'));
  test('language findthis P', '28 44 45 48 51 61 68', $gbt->findthis('P'));
  test('language findthismatch P', '28 44 45 48 51 61 68 81', $gbt->findthismatch('P')); # case sensitive
#  test('language findthismatch P', '0 1 2', $gbt->findthismatch('choices'));
  test('language findthismatch choices', '0 1 2', $gbt->findthismatch('choices'));
  test('language changethis choices', 'found choices', $gbt->changethis(0, 'found choices'));
#  test('language changethis choices', 'fond choices', $gbt->changethis(0, 'found choices'));
  test('language seethis 0', 'found choices', $gbt->seethis(0));
#  test('language changethis choices', 'suggested choices', $gbt->changethis(0, 'suggested choices'));
  test('language changethis choicesbackwards', $suggestedchoices, $gbt->changethis(0, $suggestedchoices));
  test('language changethismatch', '28 44 45 48 51 61 68 81', $gbt->changethismatch('P', 'p'));
  test('language see changed P to p', 'p', $gbt->seethis(44));
  test('language changethisones to P i', '28 44 45 48 51 61 68', $gbt->changethisones('p', 'P', 'one'));
  test('language check p to P', 'P', $gbt->seethis(28));
  test('language check p to one', 'one', $gbt->seethis(44));
#  my $blank = $gbt->changeblank();
#  test('language changethisones to P', '48 51 61', $gbt->changethisones('p', 'P', $blank->(), 'one'));
  my $blank = $gbt->changethis(67, '␢');
  test('language changethisones to P ii', '45 48 51 61 68', $gbt->changethisones('p', 'P', $blank, 'one'));
  test('language check p to P', 'P', $gbt->seethis(45));
  test('language check 48 same', 'p', $gbt->seethis(48));
  test('language check p to one', 'one', $gbt->seethis(51));
#  checkoptions($gbt);
  Games::BinaryishTrees::Trees::Loopoptions::pairs($gbt);
  my $solution = $gbt->solve(Games::BinaryishTrees::Trees::Loopoptions::pairlist());
#  my $solution = $gbt->solve(['f', 'c']);
#  $gbt->changethis(45, 'W');
  check('changethis allchoices P to W', 'W', $gbt->changethis(45, 'W'));
#  $solution->moveto('');
  checkmoveto($solution, '');
  check('allchoices P to W', 'W c f x', $solution->allchoices());
#  $solution->moveto('c:f:b');
  checkmoveto($solution, 'c:f:b');
  check('bestchoices c:f:b', 'p', $solution->bestchoices());
#  $gbt->changethis(48, 'Q');
  check('changethis bestchoices P to Q', 'Q', $gbt->changethis(48, 'Q'));
#  $solution->moveto('c:f:b');
  check('bestchoices c:f:b P to Q', 'Q', $solution->bestchoices());
#  $gbt->changethis(28, 'E');
  check('changethis legalchoice P to E', 'E', $gbt->changethis(28, 'E'));
#  $solution->moveto('c:f:b');
  check('bestchoices c:f:b P to E', 'E', $solution->legalchoices());
  check('moves c:f:b', 'c:f:b', $solution->moves());
#  $solution->moveto('c:f:b:P:a:P:P');
  checkmoveto($solution, 'c:f:b:P:a:P:P');
  check('moves c:f:b:p:a:p:p', 'c:f:b:p:a:p:p', $solution->moves());
#  $gbt->changethis(68, 'pass');
  check('changethis moves P to pass', 'pass', $gbt->changethis(68, 'pass'));
  check('moves c:f:b:pass:a:pass:pass', 'c:f:b:pass:a:pass:pass', $solution->moves());
  check('moveto c:f:b:P', 1, $solution->moveto('c:f:b:P'));
  check('gamepaths moves k:Q:Q', 'k:Q:Q', $solution->gamepaths());
  check('changethis P to foz', 'foz', $gbt->changethis(61, 'foz'));
#  $gbt->changethis(61, 'foz');
  check('gamepaths moveto c:f:b:foz', 1, $solution->moveto('c:f:b:foz'));
  check('bestpaths x:c:d:e:Q:Q', 'x:c:d:e:Q:Q', $solution->bestpaths());
  check('bvs 4', 4, $solution->bestvaluesigned('c:f:b:P:a:foz:P')); # P means P anyway # added carp see message 81
#  $solution->moveto('');
  checkmoveto($solution, '');
  check('gamepaths moves c:d:e:Q:Q', 'c:d:e:Q:Q', $solution->gamepaths());
#  is_deeply($gbt->listpairs(), {f => 1, a => 1, b => 1, c => 1, x => 1, d => 1, e => 1, k => 1, k1 => 1}, 'listpairs check');
  is_deeply($gbt->listpairs(), {f => ['a', 'b'], a => [4, 'b'], b => ['a', 3], c => [0, 1], x => ['d', 1000], d => ['e', 0], e => [10, 0], k => [5, 0], k1 => [4, 0]}, 'listpairs check');
  check('viewpair check f', "f is (a, b)\nright options of f are x\nleft options of f are x\n", $gbt->viewpair('f'));
#    $gbt->pair('j', 22, 0);
  is_deeply($gbt->pair('j', 22, 0), {j => [22, 0]}, 'pair 22 setup check');
  
  $solution = $gbt->solve(['j']);
#    $solution->changethisnumber(2, "tooty")
  check('tooty', 'tooty', $solution->changethisnumber(2, "tooty"));
#    $solution->changeallnumbers(1, {22 => '~10'});
  is_deeply({22 => '~10'}, $solution->changeallnumbers(1, {22 => '~10'}), 'changeallnumbers 22->~10');
  test('changeallnumbers on', '~10', $solution->bestvalue());
#    $solution->changeallnumbers(0, {22 => 10});
  is_deeply({}, $solution->changeallnumbers(0, {22 => '10'}), 'changeallnumbers 22->10');
  test('changeallnumbers off', 'tootytooty', $solution->bestvalue());
  check('2backto2', '2', $solution->changethisnumber(2, 2));
#    $solution->changethisnumber(2, 2);
  test('changethisnumberback', 22, $solution->bestvalue());
  test('delete pair j', 1, $gbt->deletepair('j'));
}

sub testgame {
  my ($gbt, $answersfolder) = @_;
  check('setwarningsoff 1 check', 1, $gbt->setwarningsoff(1));
#  check('setwarningson 0 check', 0, $gbt->setwarningsoff(0));
  check('delete all pairs check', 1, $gbt->deletepair());
  is_deeply({f => [0, 0]}, Games::BinaryishTrees::Trees::Steps::pairs($gbt), 'load Steps pairs check');
#  my $solution = game($gbt);
  check('check Steps::pairlist()', 'a b c d e f', @{Games::BinaryishTrees::Trees::Steps::pairlist()}); 
  my $solution = $gbt->solve(Games::BinaryishTrees::Trees::Steps::pairlist());
  check('settesting 1 check', 1, $solution->settesting(1, $answersfolder));
#  $solution->settesting(1);
#  test('play test', '-1 a:b:d:c:e:f:P:P', $solution->playgame(0, 1, 1, 1, 1, 1, 1));
  test('play test', '-1 a:b:d:c:e:f:P:P', $solution->playgame(0, 1, 1, 1, 1, 1));
#  test('play test output', readfile('playgame.txt'), readfile('clobber.txt'));
  test('play test output', readfile("$answersfolder/playgame.txt"), readfile("$answersfolder/clobber.txt"));
}

sub readfile {
  my $filepath = shift;
#  my $answersdir = './answers';
  my $content;
#  open(my $fh, '<', "$answersdir/$file") or croak "could not open file $file";
#  open(my $fh, '<', "$answersdir/$file") or croak "could not open file $answersdir/$file";
  open(my $fh, '<', $filepath) or croak "could not open file $filepath";
  {
    local $/;
    $content = <$fh>;
  }
  close($fh);
  return $content;
}

#sub carptest { # ? something odd
#  my ($object, $coderef, $testname, $answer, @params) = @_;
#  my $test = does_carp_that_matches($coderef->($object), @params, $answer);#, $testname;
#  BAIL_OUT('stop') if $bailout && !$test; 
#}

sub throwtest {
  my ($object, $coderef, $testname, $answer, @params) = @_;
  my $test = throws_ok {$coderef->($object, @params)} $answer, $testname;
  BAIL_OUT('stop') if $bailout && !$test; 
}

sub check {
  test(@_);
}

sub test {
  my ($testname, $answer, @testresult) = @_;
  my $testresult = join ' ', map { defined $_ ? $_ : 'undef' } @testresult;
  my $test = ok($testresult eq $answer, $testname);
#  BAIL_OUT("got $testresult expected $answer") if $bailout && !$test; 
  BAIL_OUT("got $testresult expected $answer") if !$test; 
}

sub testtree {
  my $gbt = shift;
  my ($string, $teststart, $testend, $goodanswers, $testname, $paramnum) = @_;
#croak ('oh');
  my @failures;

  for my $testnumber ($teststart..$testend) {
    my $params = dec2bin($paramnum, $testnumber);
#    $params .= '0'; # not checking strategy
    my @params = split '', $params;
    $gbt->setparams(@params, undef);
    my %answers = map { $_ => 1 } solvit($gbt);
#p %answers;
#    my %answers = map { $_ => 1 } solvit($gbt, $string, split '', $params);
    my @extraanswers = diff(\%answers, $goodanswers->{$params});
#BAIL_OUT('stop') if @extraanswers;
#if (@extraanswers) {
#  print join("\n", @extraanswers), "\n";
#  BAIL_OUT(''); 
#}
    push @failures, sprintf("%-6s %3s %s", $testname, $testnumber, $params) 
      unless is_deeply(\%answers, $goodanswers->{$params}, "tree test $testname $params") ||
        diag(join "\n", 'missing answers', diff($goodanswers->{$params}, \%answers), 'extra answers', @extraanswers);
    if (@failures) {
#      print Dumper $gbt;
#      $gbt->setprocessflag(2);
#      store $gbt, "${params}bad.dat";
#      print "answers given\n";
#      print join("\n", keys %answers), "\n";
      BAIL_OUT('stop') if $bailout;
    }
#    if (@extraanswers) {
#      print join("\n", @extraanswers), "\n";
#      print "answers given\n";
#      print join("\n", keys %answers), "\n";
#      BAIL_OUT(''); 
#    }
  }

  return @failures;
}
=in Trees
sub ko {
  my $gbt = shift;
  $gbt->pair('f', 'a', 'b');
  $gbt->pair('a', 4, 'b');
  $gbt->pair('b', 'a', 3);
  $gbt->pair('c', 0, 1);
  $gbt->pair('d', 'e', 0);
  $gbt->pair('e', 10, 0);
}

sub simple {
  my $gbt = shift;
  $gbt->pair('a', 1, 0);
  $gbt->pair('b', 0, 1);
  $gbt->pair('c', 10, 0);
}
sub pook {
  my $gbt = shift;
  $gbt->setwarningsoff(1);
  $gbt->pair('a', 3, 0, undef, undef, {'c' => [2, 0]});
  $gbt->pair('b', 1, 0);
  $gbt->pair('c', 10, 0);
}
sub checkoptions {
  my $gbt = shift;
  $gbt->pair('f', 'a', 'b');
  $gbt->option('left', 'f', 'x');
  $gbt->option('left', 'a', 'k', 'k1'); 
  $gbt->option('right', 'f', 'x'); 
  $gbt->pair('a', 4, 'b');
  $gbt->pair('b', 'a', 3);
  $gbt->pair('c', 0, 1);
  $gbt->pair('x', 'd', 1000);
  $gbt->pair('d', 'e', 0);
  $gbt->pair('e', 10, 0);
  $gbt->pair('k', 5, 0);
  $gbt->pair('k1', 4, 0);
}
sub game {
  my $gbt = shift;
  $gbt->pair('a', 5, 0);
  $gbt->pair('b', 4, 0);
  $gbt->pair('c', 3, 0);
  $gbt->pair('d', 2, 0);
  $gbt->pair('e', 1, 0);
  $gbt->pair('f', 0, 0);
  return $gbt->solve(['a', 'b', 'c', 'd', 'e', 'f']);
}
=cut
sub diff {
  my ($x, $y) = @_;
  return grep !exists $y->{$_}, keys %$x;
}

sub solvit {
  my $gbt = shift;
#  my ($gbt, $string, @params) = @_;
#  my $solution = $gbt->solve($string);
  my $solution = $gbt->solve;
  return $solution->bestvalue, $solution->bestpaths;
}

sub dec2bin { # adds a 0 at the end when not sent enough
  my $paramnum = shift;
  my $str = unpack('B32', pack('N', shift));
  my $remove = '0' x (32 - $paramnum);
  $str =~ s/^$remove//;
  return $str;
}
