use strict; 
use warnings;
use lib '../lib';

use Games::BinaryishTrees;
use Games::BinaryishTrees::Trees::Loop;
use Games::BinaryishTrees::Trees::Simple;
use Games::BinaryishTrees::Trees::Pook;

# for simple way test place a choose inside Games::BinaryishTrees $self->{switches} frontway
# for simple way play move this choose to otherend
# ooh - anyway we can redesign isok so all choose is setthis from lazyfellow_wakeupway
my $gbt = new Games::BinaryishTrees;
my $tree;
my $param = shift;
#$param || 0;
#$param ||= 0;
if ($param && ($param eq 'loop' || $param eq 'simple' || $param eq 'pook')) {
  if ($param eq 'loop') {
#  if ($param eq 'ko') {
#    testko($gbt);
    Games::BinaryishTrees::Trees::Loop::pairs($gbt);
    $tree = Games::BinaryishTrees::Trees::Loop::pairlist();
#    $tree = ['f', 'c', 'd'];
  } elsif ($param eq 'simple') {
#    testsimple($gbt);
    Games::BinaryishTrees::Trees::Simple::pairs($gbt);
    $tree = Games::BinaryishTrees::Trees::Simple::pairlist();
#    $tree = ['a', 'b', 'c'];
  } elsif ($param eq 'pook') {
#    testpook($gbt);
    Games::BinaryishTrees::Trees::Pook::pairs($gbt);
    $tree = Games::BinaryishTrees::Trees::Pook::pairlist();
#    $tree = ['a', 'b', 'c'];
  }
  my $paramnum = 8;
  testtree($gbt, $tree, 0, 2**$paramnum - 1, $paramnum);
} else {
  print "usage : gbtmakedata.pl [loop simple pook]\n";
}

sub testtree {
  my ($gbt, $tree, $teststart, $testend, $paramnum) = @_;

  for ($teststart..$testend) {
    my $params = dec2bin($paramnum, $_);
    my @answers = solvit($gbt, $tree, split '', $params);
    print "$params\n", join("\n", sort @answers), "\n";
  }

  print "\n";
}

sub solvit {
  my ($gbt, $string, @params) = @_;
  my $solution = $gbt->solve($string, @params);
  return $solution->bestvalue(), $solution->bestpaths()
}

sub dec2bin { # adds a 0 at the end when not sent enough
  my $paramnum = shift;
  my $str = unpack('B32', pack('N', shift));
  my $remove = '0' x (32 - $paramnum);
  $str =~ s/^$remove//;
  return $str;
}
=in Trees
sub testko {
  my $gbt = shift;
  $gbt->pair('f', 'a', 'b');
  $gbt->pair('a', 4, 'b');
  $gbt->pair('b', 'a', 3);
  $gbt->pair('c', 0, 1);
  $gbt->pair('d', 'e', 0);
  $gbt->pair('e', 10, 0);
}

sub testsimple {
  my $gbt = shift;
  $gbt->pair('a', 1, 0);
  $gbt->pair('b', 0, 1);
  $gbt->pair('c', 10, 0);
}

sub testpook {
  my $gbt = shift;
  $gbt->setwarningsoff(1);
  $gbt->pair('a', 3, 0, undef, undef, {'c' => [2, 0]});
  $gbt->pair('b', 1, 0);
  $gbt->pair('c', 10, 0);
}
=cut

