#use 5.12.0;
use strict;
use warnings;

use Test::More tests => 24; # looks ok until run by "make test" as check.t # subtests # ah print ok() issue 
#use Carp;

chdir './t/checks';
my $peekanswers = peekanswers();
my $treejsonfolderpath = '../../lib/Games/BinaryishTrees/TreesJSON/';

SKIP: {
  eval { require JSON::MaybeXS };
  skip "missing JSON::MaybeXS", 2 if $@;
#  subtest 'subtest 1', sub {
#my $check = 'simplejson';
#my $output = `perl $check.pl 1`;
#checkthem($output, $peekanswers->{$check}, "$check.pl");
  setupcheckone('simplejson', 1);
#    done_testing();
#  };
#  subtest 'subtest 2', sub {
  setupcheckone('jsonread', $treejsonfolderpath);
#$check = 'jsonread';
#$output = `perl $check.pl`;
#print $output;
#checkthem($output, $peekanswers->{$check}, "$check.pl");
#    done_testing();
#  };
}

my $answers = {simple => 0, steps => 1, stepstwo => 1, loop => 0, loopoptions => 0, options => 1, pook => 0};
my $jsonanswers = {overlaps => 0};

for my $key (keys %$answers) {
  my $output = `perl peek.pl $key`;
  checkthem($output, $peekanswers->{$key}, "peek.pl $key");
#  checkthem($output, peekanswers($key), "peek.pl $key");
#  my $result = checkthem($output, peekanswers($key), "peek.pl $key");
#  print "$output, $key\n" if $result eq "oh\n";
}

#  subtest 'subtest 4', sub {

for my $key (keys %$answers) {
  my $output = `perl symmetry.pl $key`;
  my $value = $answers->{$key} ? "equal\n" : "differing\n";
  checkthem($output, $value, "symmetry.pl $key");
}
#    done_testing();
#  };



#chdir '../../patterns';

#  subtest 'subtest 3', sub {

SKIP: {
  eval { require JSON::MaybeXS };
#  skip "missing JSON::MaybeXS", 7 if $@;
  skip "missing JSON::MaybeXS", 8 if $@;  

  for my $key (keys %$answers) {
    my $output = `perl symmetryJSON.pl $key.json $treejsonfolderpath`;
    checkthem($output, $answers->{$key} ? "equal\n" : "differing\n", "symmetryJSON.pl $key.json");
  }

  my $output = `perl strategyJSON.pl stepsdown.json $treejsonfolderpath`;
  checkthem($output, $peekanswers->{stepsdown}, "strategyJSON.pl stepsdown");
}

sub checkthem {
  my ($output, $message, $check) = @_;
#  ok($output eq $message, $check);
#  if ($output eq $message) {
#    return "ok\n";
#  } else {
#    croak "found\n$output\nlooking for\n$message\n"; 
##    return "oh\n";
#  }
  BAIL_OUT("$check\nfound\n$output\nlooking for\n$message\n") unless ok($output eq $message, $check);
}

sub setupcheckone {
  my ($check, @params) = @_;
  my $output = `perl $check.pl @params`;
  checkthem($output, $peekanswers->{$check}, "$check.pl");
}

sub peekanswers {
#  my $key = shift;
  my $simple = <<'simple';
a is (1, 0)
b is (0, 1)
c is (10, 0)
solve a b c
c:P:P
c:P:a:b:P:P
c:P:b:a:P:P
c:a:b:P:P
c:b:a:P:P
10
simple
  my $steps = <<'steps';
a is (5, 0)
b is (4, 0)
c is (3, 0)
d is (2, 0)
e is (1, 0)
f is (0, 0)
solve a b c d e f
a:b:c:d:e:P:P
a:b:c:d:e:P:f:P:P
a:b:c:d:e:f:P:P
9
steps
  my $stepstwo = <<'stepstwo';
a123 is (5, 0)
b1 is (4, 0)
c12 is (3, 0)
c123 is (2, 0)
d2 is (1, 0)
d3 is (0, 0)
solve a123 b1 c12 c123 d2 d3
a123:b1:c12:c123:d2:P:P
a123:b1:c12:c123:d2:P:d3:P:P
a123:b1:c12:c123:d2:d3:P:P
9
stepstwo
  my $loopoptions = <<'loopoptions';
a is (4, b)
b is (a, 3)
c is (0, 1)
d is (e, 0)
e is (10, 0)
f is (a, b)
k is (5, 0)
k1 is (4, 0)
x is (d, 1000)
right options of f are x
left options of a are k k1
left options of f are x
solve f c
x:c:P:P
x:c:P:d:P:P
x:c:d:e:P:P
-1
loopoptions
  my $loop = <<'loop';
a is (4, b)
b is (a, 3)
c is (0, 1)
d is (e, 0)
e is (10, 0)
f is (a, b)
solve f c d
f:a:d:e:b:P:a:c:P:P
f:a:d:e:b:c:a:P:P
f:c:a:P:P
f:c:a:P:d:e:P:P
f:c:a:d:P:P
f:c:d:e:a:P:P
f:d:a:c:P:P
3
loop
  my $options = <<'options';
b is (4, 0)
c is (3, 0)
d is (2, 0)
right options of b are d
left options of c are b
solve b c
b:b:P:P
b:c:P:P
b:d:P:P
4
options
  my $pook = <<'pook';
a is (3, 0)
b is (1, 0)
c is (10, 0)
a pooks c to (2, 0)
solve a b c
c:a:b:P:P
11
pook
  my $simplejson = <<'simplejson';
a:b:d:P:P
a:c:b:P:P
b:a:d:P:P
b:c:a:P:P
d:a:b:P:P
d:b:a:P:P
simplejson
  my $jsonread = <<'jsonread';
complex.json
abckj
b:a:a1:c:j:k:h:m:P:P
b:a:a1:c:j:k:m:h:P:P
b:a:a1:c:k:j:i:l:P:P
b:a:a1:c:k:j:l:i:P:P
11
loop.json
fcd
d:e:c:f:b:P:a:P:P
4
loopoptions.json
fc
x:c:d:e:P:P
-1
options.json
bc
b:b:P:P
b:c:P:P
b:d:P:P
4
overlaps.json
aaa
a:a:a:P:ab:ab:b:a:P:P
a:a:ab:a:b:P:P
2
pook.json
abc
c:a:b:P:P
11
simple.json
abc
c:a:b:P:P
c:b:a:P:P
10
steps.json
abcdef
a:b:c:d:e:f:P:P
9
stepsdown.json
abc
a:c:b:P:P
1
stepstwo.json
a123b1c12c123d2d3
a123:b1:c12:c123:d2:d3:P:P
9
jsonread
  my $stepsdown = <<'stepsdown';
P:b:P:c:a:P:P
P:b:a:P:P
P:b:a:c:P:P
P:c:P:b:a:P:P
P:c:a:P:P
P:c:a:b:P:P
a:P:P
a:b:P:P
a:b:P:c:P:P
a:c:P:P
a:c:P:b:P:P
3
P:b:P:c:a:P:P
P:b:a:P:P
P:b:a:c:P:P
P:c:P:b:a:P:P
P:c:a:P:P
P:c:a:b:P:P
a:P:P
a:b:P:P
a:b:P:c:P:P
a:c:P:P
a:c:P:b:P:P
3
P:a:P:P
P:a:b:P:P
P:a:b:P:c:P:P
P:a:c:P:P
P:a:c:P:b:P:P
b:P:c:a:P:P
b:a:P:P
b:a:c:P:P
c:P:b:a:P:P
c:a:P:P
c:a:b:P:P
3
P:a:P:P
P:a:b:P:P
P:a:b:P:c:P:P
P:a:c:P:P
P:a:c:P:b:P:P
b:P:c:a:P:P
b:a:P:P
b:a:c:P:P
c:P:b:a:P:P
c:a:P:P
c:a:b:P:P
3
stepsdown
  my $answers = {
    simple => $simple, 
    steps => $steps, 
    stepstwo => $stepstwo, 
    loop => $loop, 
    loopoptions => $loopoptions, 
    options => $options, 
    pook => $pook,
    simplejson => $simplejson,
    jsonread => $jsonread,
    stepsdown => $stepsdown
  };
#  return $answers->{$key};
  return $answers;
}
